
;CodeVisionAVR C Compiler V2.03.4 Standard
;(C) Copyright 1998-2008 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type              : ATmega8
;Program type           : Application
;Clock frequency        : 4,000000 MHz
;Memory model           : Small
;Optimize for           : Size
;(s)printf features     : int, width
;(s)scanf features      : int, width
;External RAM size      : 0
;Data Stack size        : 256 byte(s)
;Heap size              : 0 byte(s)
;Promote char to int    : Yes
;char is unsigned       : Yes
;global const stored in FLASH  : No
;8 bit enums            : Yes
;Enhanced core instructions    : On
;Smart register allocation : On
;Automatic register allocation : On

	#pragma AVRPART ADMIN PART_NAME ATmega8
	#pragma AVRPART MEMORY PROG_FLASH 8192
	#pragma AVRPART MEMORY EEPROM 512
	#pragma AVRPART MEMORY INT_SRAM SIZE 1024
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x60

	.LISTMAC
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU GICR=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+@1
	ANDI R30,LOW(@2)
	STS  @0+@1,R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+@1
	ANDI R30,LOW(@2)
	STS  @0+@1,R30
	LDS  R30,@0+@1+1
	ANDI R30,HIGH(@2)
	STS  @0+@1+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ANDD2N
	ANDI R26,LOW(@0)
	ANDI R27,HIGH(@0)
	ANDI R24,BYTE3(@0)
	ANDI R25,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+@1
	ORI  R30,LOW(@2)
	STS  @0+@1,R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+@1
	ORI  R30,LOW(@2)
	STS  @0+@1,R30
	LDS  R30,@0+@1+1
	ORI  R30,HIGH(@2)
	STS  @0+@1+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD2N
	ORI  R26,LOW(@0)
	ORI  R27,HIGH(@0)
	ORI  R24,BYTE3(@0)
	ORI  R25,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __CLRD1S
	LDI  R30,0
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+@1)
	LDI  R31,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	LDI  R22,BYTE3(2*@0+@1)
	LDI  R23,BYTE4(2*@0+@1)
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+@2)
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+@3)
	LDI  R@1,HIGH(@2+@3)
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+@3)
	LDI  R@1,HIGH(@2*2+@3)
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+@1
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+@1
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	LDS  R22,@0+@1+2
	LDS  R23,@0+@1+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+@2
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+@3
	LDS  R@1,@2+@3+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+@1
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	LDS  R24,@0+@1+2
	LDS  R25,@0+@1+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+@1,R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	STS  @0+@1+2,R22
	STS  @0+@1+3,R23
	.ENDM

	.MACRO __PUTB1EN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	RCALL __EEPROMWRB
	.ENDM

	.MACRO __PUTW1EN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	RCALL __EEPROMWRW
	.ENDM

	.MACRO __PUTD1EN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	RCALL __EEPROMWRD
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+@1,R0
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+@1,R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+@1,R@2
	STS  @0+@1+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	RCALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	RCALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	RCALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __CLRD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R@1
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRR0
	MULS R@0,R@1
	.ENDM

	.MACRO __MULBRRU0
	MUL  R@0,R@1
	.ENDM

	.MACRO __MULBNWRU
	LDI  R26,@2
	MUL  R26,R@0
	MOVW R30,R0
	MUL  R26,R@1
	ADD  R31,R0
	.ENDM

;NAME DEFINITIONS FOR GLOBAL VARIABLES ALLOCATED TO REGISTERS
	.DEF _pauseind=R4
	.DEF _taho1=R6
	.DEF _taho2=R8
	.DEF _taho3=R10
	.DEF _taho4=R12

	.CSEG
	.ORG 0x00

;INTERRUPT VECTORS
	RJMP __RESET
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP _timer2_ovf_isr
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP _timer0_ovf_isr
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP _adc_isr
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00

_tbl10_G101:
	.DB  0x10,0x27,0xE8,0x3,0x64,0x0,0xA,0x0
	.DB  0x1,0x0
_tbl16_G101:
	.DB  0x0,0x10,0x0,0x1,0x10,0x0,0x1,0x0

_0x0:
	.DB  0xBF,0xC7,0xBD,0x79,0xE6,0x65,0x65,0x20
	.DB  0x6F,0x63,0xBF,0x61,0xBD,0x6F,0xB3,0x20
	.DB  0x0,0xBF,0xC7,0xBD,0x79,0xE6,0x65,0x65
	.DB  0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20
	.DB  0x20,0x20,0x20,0x20,0x20,0x0,0x74,0x61
	.DB  0x68,0x6F,0x3D,0x25,0x75,0x20,0x2C,0xAC
	.DB  0xA5,0x4D,0x3D,0x25,0x75,0x20,0x20,0x20
	.DB  0x20,0x20,0x20,0x20,0x20,0x0,0xB3,0xC3
	.DB  0xB2,0x6F,0x70,0x20,0xBF,0x70,0x79,0xB2
	.DB  0xC3,0x20,0x20,0x20,0x20,0x20,0x0,0x44
	.DB  0x32,0x30,0x20,0x50,0x45,0x33,0x32,0x20
	.DB  0x36,0x41,0x54,0x20,0x20,0x20,0x20,0x0
	.DB  0x44,0x32,0x30,0x20,0x50,0x45,0x33,0x32
	.DB  0x20,0x31,0x30,0x41,0x54,0x20,0x20,0x20
	.DB  0x0,0x44,0x32,0x30,0x20,0x50,0x45,0x36
	.DB  0x33,0x20,0x31,0x30,0x41,0x54,0x20,0x20
	.DB  0x20,0x0,0x44,0x32,0x30,0x20,0x50,0x45
	.DB  0x38,0x30,0x20,0x31,0x32,0x2C,0x35,0x41
	.DB  0x54,0x20,0x0,0x44,0x32,0x30,0x20,0x50
	.DB  0x45,0x38,0x30,0x20,0x31,0x36,0x41,0x54
	.DB  0x20,0x20,0x20,0x0,0x44,0x32,0x35,0x20
	.DB  0x50,0x45,0x33,0x32,0x20,0x34,0x41,0x54
	.DB  0x20,0x20,0x20,0x20,0x0,0x44,0x32,0x35
	.DB  0x20,0x50,0x45,0x33,0x32,0x20,0x36,0x41
	.DB  0x54,0x20,0x20,0x20,0x20,0x0,0x44,0x32
	.DB  0x35,0x20,0x50,0x45,0x33,0x32,0x20,0x31
	.DB  0x30,0x41,0x54,0x20,0x20,0x20,0x0,0x44
	.DB  0x32,0x35,0x20,0x50,0x45,0x36,0x33,0x20
	.DB  0x36,0x41,0x54,0x20,0x20,0x20,0x20,0x0
	.DB  0x44,0x32,0x35,0x20,0x50,0x45,0x36,0x33
	.DB  0x20,0x31,0x30,0x41,0x54,0x20,0x20,0x20
	.DB  0x0,0x44,0x32,0x35,0x20,0x50,0x45,0x38
	.DB  0x30,0x20,0x31,0x30,0x41,0x54,0x20,0x20
	.DB  0x20,0x0,0x44,0x32,0x35,0x20,0x50,0x45
	.DB  0x38,0x30,0x20,0x31,0x32,0x2C,0x35,0x41
	.DB  0x54,0x20,0x0,0x44,0x32,0x35,0x20,0x50
	.DB  0x45,0x38,0x30,0x20,0x31,0x36,0x41,0x54
	.DB  0x20,0x20,0x20,0x0,0x44,0x33,0x32,0x20
	.DB  0x50,0x45,0x33,0x32,0x20,0x34,0x41,0x54
	.DB  0x20,0x20,0x20,0x20,0x0,0x44,0x33,0x32
	.DB  0x20,0x50,0x45,0x33,0x32,0x20,0x36,0x41
	.DB  0x54,0x20,0x20,0x20,0x20,0x0,0x44,0x33
	.DB  0x32,0x20,0x50,0x45,0x33,0x32,0x20,0x31
	.DB  0x30,0x41,0x54,0x20,0x20,0x20,0x0,0x44
	.DB  0x33,0x32,0x20,0x50,0x45,0x36,0x33,0x20
	.DB  0x36,0x41,0x54,0x20,0x20,0x20,0x20,0x0
	.DB  0x44,0x33,0x32,0x20,0x50,0x45,0x36,0x33
	.DB  0x20,0x31,0x30,0x41,0x54,0x20,0x20,0x20
	.DB  0x0,0x44,0x33,0x32,0x20,0x50,0x45,0x38
	.DB  0x30,0x20,0x38,0x41,0x54,0x20,0x20,0x20
	.DB  0x20,0x0,0x44,0x33,0x32,0x20,0x50,0x45
	.DB  0x38,0x30,0x20,0x31,0x30,0x41,0x54,0x20
	.DB  0x20,0x20,0x0,0x44,0x33,0x32,0x20,0x50
	.DB  0x45,0x38,0x30,0x20,0x31,0x32,0x2C,0x35
	.DB  0x41,0x54,0x20,0x0,0x44,0x33,0x32,0x20
	.DB  0x50,0x45,0x38,0x30,0x20,0x31,0x36,0x41
	.DB  0x54,0x20,0x20,0x20,0x0,0x44,0x34,0x30
	.DB  0x20,0x50,0x45,0x33,0x32,0x20,0x34,0x41
	.DB  0x54,0x20,0x20,0x20,0x20,0x0,0x44,0x34
	.DB  0x30,0x20,0x50,0x45,0x33,0x32,0x20,0x36
	.DB  0x41,0x54,0x20,0x20,0x20,0x20,0x0,0x44
	.DB  0x34,0x30,0x20,0x50,0x45,0x33,0x32,0x20
	.DB  0x31,0x30,0x41,0x54,0x20,0x20,0x20,0x0
	.DB  0x44,0x34,0x30,0x20,0x50,0x45,0x36,0x33
	.DB  0x20,0x36,0x41,0x54,0x20,0x20,0x20,0x20
	.DB  0x0,0x44,0x34,0x30,0x20,0x50,0x45,0x36
	.DB  0x33,0x20,0x31,0x30,0x41,0x54,0x20,0x20
	.DB  0x20,0x0,0x44,0x34,0x30,0x20,0x50,0x45
	.DB  0x38,0x30,0x20,0x38,0x41,0x54,0x20,0x20
	.DB  0x20,0x20,0x0,0x44,0x34,0x30,0x20,0x50
	.DB  0x45,0x38,0x30,0x20,0x31,0x30,0x41,0x54
	.DB  0x20,0x20,0x20,0x0,0x44,0x34,0x30,0x20
	.DB  0x50,0x45,0x38,0x30,0x20,0x31,0x32,0x2C
	.DB  0x35,0x41,0x54,0x20,0x0,0x44,0x34,0x30
	.DB  0x20,0x50,0x45,0x38,0x30,0x20,0x31,0x36
	.DB  0x41,0x54,0x20,0x20,0x20,0x0,0x44,0x35
	.DB  0x30,0x20,0x50,0x45,0x33,0x32,0x20,0x34
	.DB  0x41,0x54,0x20,0x20,0x20,0x20,0x0,0x44
	.DB  0x35,0x30,0x20,0x50,0x45,0x33,0x32,0x20
	.DB  0x36,0x41,0x54,0x20,0x20,0x20,0x20,0x0
	.DB  0x44,0x35,0x30,0x20,0x50,0x45,0x33,0x32
	.DB  0x20,0x31,0x30,0x41,0x54,0x20,0x20,0x20
	.DB  0x0,0x44,0x35,0x30,0x20,0x50,0x45,0x36
	.DB  0x33,0x20,0x36,0x41,0x54,0x20,0x20,0x20
	.DB  0x20,0x0,0x44,0x35,0x30,0x20,0x50,0x45
	.DB  0x36,0x33,0x20,0x31,0x30,0x41,0x54,0x20
	.DB  0x20,0x20,0x0,0x44,0x35,0x30,0x20,0x50
	.DB  0x45,0x38,0x30,0x20,0x38,0x41,0x54,0x20
	.DB  0x20,0x20,0x20,0x0,0x44,0x35,0x30,0x20
	.DB  0x50,0x45,0x38,0x30,0x20,0x31,0x30,0x41
	.DB  0x54,0x20,0x20,0x20,0x0,0x44,0x35,0x30
	.DB  0x20,0x50,0x45,0x38,0x30,0x20,0x31,0x32
	.DB  0x2C,0x35,0x41,0x54,0x20,0x0,0x44,0x35
	.DB  0x30,0x20,0x50,0x45,0x38,0x30,0x20,0x31
	.DB  0x36,0x41,0x54,0x20,0x20,0x20,0x0,0xB7
	.DB  0x61,0xE3,0x61,0xBD,0xB8,0x65,0x20,0x63
	.DB  0xBA,0x6F,0x70,0x63,0xBF,0xB8,0x20,0x0
	.DB  0xB7,0x61,0xE3,0x61,0xBD,0xB8,0x65,0x3D
	.DB  0x25,0x75,0x20,0x20,0x20,0x20,0x20,0x20
	.DB  0x20,0x0,0x63,0xBA,0x6F,0x70,0x63,0xBF
	.DB  0xC4,0x20,0xBD,0x65,0xBE,0x6F,0x63,0x70
	.DB  0x20,0x20,0x0,0x70,0x77,0x6D,0x3D,0x25
	.DB  0x75,0x20,0x20,0x20,0x20,0x20,0x20,0x20
	.DB  0x20,0x20,0x20,0x20,0x0,0xB3,0xB3,0x65
	.DB  0xE3,0xB8,0xBF,0x65,0x20,0x70,0x65,0x61
	.DB  0xBA,0xE5,0xB8,0xC6,0x20,0x0,0x74,0x3D
	.DB  0x25,0x75,0x20,0x20,0x20,0x20,0x20,0x20
	.DB  0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x0
_0x2000003:
	.DB  0x80,0xC0

__GLOBAL_INI_TBL:
	.DW  0x02
	.DW  __base_y_G100
	.DW  _0x2000003*2

_0xFFFFFFFF:
	.DW  0

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  GICR,R31
	OUT  GICR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,(14-2)+1
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x400)
	LDI  R25,HIGH(0x400)
	LDI  R26,0x60
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0x45F)
	OUT  SPL,R30
	LDI  R30,HIGH(0x45F)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0x160)
	LDI  R29,HIGH(0x160)

	RJMP _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x160

	.CSEG
;/*****************************************************
;This program was produced by the
;CodeWizardAVR V2.03.4 Standard
;Automatic Program Generator
; Copyright 1998-2008 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com
;
;Project :
;Version :
;Date    : 16.09.2009
;Author  :
;Company :
;Comments:
;
;
;Chip type           : ATmega8
;Program type        : Application
;Clock frequency     : 4,000000 MHz
;Memory model        : Small
;External RAM size   : 0
;Data Stack size     : 256
;*****************************************************/
;
;#include <mega8.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
;
;// Alphanumeric LCD Module functions
;#asm
   .equ __lcd_port=0x12 ;PORTD
; 0000 001D #endasm
;#include <lcd.h>
;#include <stdio.h>
;#define menu PINB.2
;#define enter PINB.3
;#define plus PINB.4
;#define minus PINB.5
;#define sw1 PINC.5
;#define sw2 PINC.4
;#define ADC_VREF_TYPE 0x40
;
;
;char lcd_buffer[33];
;int  pauseind, taho1, taho2, taho3, taho4, taho5, taho6, taho7, taho8, taho9, taho10,taho11, taho, pwm, zadanie[40], ust_cnt_pwm;
;unsigned char   truba, ind,  rejim, menu_pres,plus_pres, plus_press, minus_pres, minus_press,pz_btn, cnt_pwm;
;eeprom int zadanie_mem[40];
;eeprom unsigned char ust_cnt_pwm_mem=10, truba_mem=1;
;
;void vichisl (void)
; 0000 0030 {

	.CSEG
_vichisl:
; 0000 0031 if(rejim!=3)
	RCALL SUBOPT_0x0
	CPI  R26,LOW(0x3)
	BREQ _0x3
; 0000 0032 {
; 0000 0033 if(taho<zadanie[truba])
	RCALL SUBOPT_0x1
	RCALL SUBOPT_0x2
	CP   R26,R30
	CPC  R27,R31
	BRGE _0x4
; 0000 0034  {
; 0000 0035  if(taho+50<zadanie[truba] && pwm<1000)pwm=pwm+5;
	RCALL SUBOPT_0x3
	ADIW R30,50
	MOVW R0,R30
	RCALL SUBOPT_0x1
	CP   R0,R30
	CPC  R1,R31
	BRGE _0x6
	RCALL SUBOPT_0x4
	BRLT _0x7
_0x6:
	RJMP _0x5
_0x7:
	RCALL SUBOPT_0x5
	ADIW R30,5
	RCALL SUBOPT_0x6
; 0000 0036  else
	RJMP _0x8
_0x5:
; 0000 0037  {
; 0000 0038  if(pwm<1000) pwm++;
	RCALL SUBOPT_0x4
	BRGE _0x9
	RCALL SUBOPT_0x7
	RCALL SUBOPT_0x8
; 0000 0039  }
_0x9:
_0x8:
; 0000 003A  }
; 0000 003B if(taho>zadanie[truba])
_0x4:
	RCALL SUBOPT_0x1
	RCALL SUBOPT_0x2
	RCALL SUBOPT_0x9
	BRGE _0xA
; 0000 003C  {
; 0000 003D  if(taho>zadanie[truba]+50 && pwm>5)pwm=pwm-5;
	RCALL SUBOPT_0x1
	ADIW R30,50
	RCALL SUBOPT_0x2
	RCALL SUBOPT_0x9
	BRGE _0xC
	RCALL SUBOPT_0xA
	SBIW R26,6
	BRGE _0xD
_0xC:
	RJMP _0xB
_0xD:
	RCALL SUBOPT_0x5
	SBIW R30,5
	RCALL SUBOPT_0x6
; 0000 003E  else
	RJMP _0xE
_0xB:
; 0000 003F  {
; 0000 0040  if(pwm>0) pwm--;
	RCALL SUBOPT_0xA
	RCALL __CPW02
	BRGE _0xF
	RCALL SUBOPT_0x7
	RCALL SUBOPT_0xB
; 0000 0041  }
_0xF:
_0xE:
; 0000 0042  }
; 0000 0043 }
_0xA:
; 0000 0044 if(sw1==0)pwm=0;
_0x3:
	SBIC 0x13,5
	RJMP _0x10
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	RCALL SUBOPT_0x6
; 0000 0045 OCR1AH=pwm>>8;
_0x10:
	RCALL SUBOPT_0x5
	RCALL __ASRW8
	OUT  0x2B,R30
; 0000 0046 OCR1AL=pwm;
	RCALL SUBOPT_0x5
	OUT  0x2A,R30
; 0000 0047 
; 0000 0048 }
	RET
;// Timer 0 overflow interrupt service routine  61   (0.0164)
;interrupt [TIM0_OVF] void timer0_ovf_isr(void)
; 0000 004B {
_timer0_ovf_isr:
	ST   -Y,R0
	ST   -Y,R1
	ST   -Y,R15
	ST   -Y,R22
	ST   -Y,R23
	ST   -Y,R24
	ST   -Y,R25
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
; 0000 004C // Place your code here
; 0000 004D if(ind!=0)pauseind++;
	LDS  R30,_ind
	CPI  R30,0
	BREQ _0x11
	MOVW R30,R4
	ADIW R30,1
	MOVW R4,R30
	SBIW R30,1
; 0000 004E if(pauseind==1000)
_0x11:
	LDI  R30,LOW(1000)
	LDI  R31,HIGH(1000)
	CP   R30,R4
	CPC  R31,R5
	BRNE _0x12
; 0000 004F {
; 0000 0050 rejim=0;
	LDI  R30,LOW(0)
	STS  _rejim,R30
; 0000 0051 ind=0;
	STS  _ind,R30
; 0000 0052 pauseind=0;
	CLR  R4
	CLR  R5
; 0000 0053 }
; 0000 0054 
; 0000 0055 cnt_pwm++;
_0x12:
	LDS  R30,_cnt_pwm
	SUBI R30,-LOW(1)
	STS  _cnt_pwm,R30
; 0000 0056 if(cnt_pwm==ust_cnt_pwm)
	RCALL SUBOPT_0xC
	LDS  R26,_cnt_pwm
	RCALL SUBOPT_0xD
	BRNE _0x13
; 0000 0057   {
; 0000 0058   cnt_pwm=0;
	LDI  R30,LOW(0)
	STS  _cnt_pwm,R30
; 0000 0059   vichisl();
	RCALL _vichisl
; 0000 005A   }
; 0000 005B if( (plus_pres && minus_pres)==0)pz_btn++;
_0x13:
	LDS  R30,_plus_pres
	CPI  R30,0
	BREQ _0x15
	LDS  R30,_minus_pres
	CPI  R30,0
	BRNE _0x14
_0x15:
	LDS  R30,_pz_btn
	SUBI R30,-LOW(1)
	RJMP _0xA6
; 0000 005C else pz_btn=0;
_0x14:
	LDI  R30,LOW(0)
_0xA6:
	STS  _pz_btn,R30
; 0000 005D }
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R25,Y+
	LD   R24,Y+
	LD   R23,Y+
	LD   R22,Y+
	LD   R15,Y+
	LD   R1,Y+
	LD   R0,Y+
	RETI
;
;// Timer 2 overflow interrupt service routine
;interrupt [TIM2_OVF] void timer2_ovf_isr(void)
; 0000 0061 {
_timer2_ovf_isr:
; 0000 0062 // Place your code here
; 0000 0063 
; 0000 0064 }
	RETI
;
;
;
;// ADC interrupt service routine
;interrupt [ADC_INT] void adc_isr(void)
; 0000 006A {
_adc_isr:
	ST   -Y,R0
	ST   -Y,R1
	ST   -Y,R25
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
; 0000 006B // Read the AD conversion result
; 0000 006C taho11=taho10;
	LDS  R30,_taho10
	LDS  R31,_taho10+1
	STS  _taho11,R30
	STS  _taho11+1,R31
; 0000 006D taho10=taho9;
	LDS  R30,_taho9
	LDS  R31,_taho9+1
	STS  _taho10,R30
	STS  _taho10+1,R31
; 0000 006E taho9=taho8;
	LDS  R30,_taho8
	LDS  R31,_taho8+1
	STS  _taho9,R30
	STS  _taho9+1,R31
; 0000 006F taho8=taho7;
	LDS  R30,_taho7
	LDS  R31,_taho7+1
	STS  _taho8,R30
	STS  _taho8+1,R31
; 0000 0070 taho7=taho6;
	LDS  R30,_taho6
	LDS  R31,_taho6+1
	STS  _taho7,R30
	STS  _taho7+1,R31
; 0000 0071 taho6=taho5;
	LDS  R30,_taho5
	LDS  R31,_taho5+1
	STS  _taho6,R30
	STS  _taho6+1,R31
; 0000 0072 taho5=taho4;
	__PUTWMRN _taho5,0,12,13
; 0000 0073 taho4=taho3;
	MOVW R12,R10
; 0000 0074 taho3=taho2;
	MOVW R10,R8
; 0000 0075 taho2=taho1;
	MOVW R8,R6
; 0000 0076 taho1=ADCW;
	__INWR 6,7,4
; 0000 0077 taho=(taho1+taho2+taho3+taho4+taho5+taho6+taho7+taho8+taho9+taho10+taho11)/11;
	MOVW R30,R8
	ADD  R30,R6
	ADC  R31,R7
	ADD  R30,R10
	ADC  R31,R11
	ADD  R30,R12
	ADC  R31,R13
	LDS  R26,_taho5
	LDS  R27,_taho5+1
	RCALL SUBOPT_0xE
	LDS  R26,_taho6
	LDS  R27,_taho6+1
	RCALL SUBOPT_0xE
	LDS  R26,_taho7
	LDS  R27,_taho7+1
	RCALL SUBOPT_0xE
	LDS  R26,_taho8
	LDS  R27,_taho8+1
	RCALL SUBOPT_0xE
	LDS  R26,_taho9
	LDS  R27,_taho9+1
	RCALL SUBOPT_0xE
	LDS  R26,_taho10
	LDS  R27,_taho10+1
	RCALL SUBOPT_0xE
	LDS  R26,_taho11
	LDS  R27,_taho11+1
	RCALL SUBOPT_0xF
	LDI  R30,LOW(11)
	LDI  R31,HIGH(11)
	RCALL __DIVW21
	STS  _taho,R30
	STS  _taho+1,R31
; 0000 0078 // Place your code here
; 0000 0079 ADCSRA|=0x40;
	RCALL SUBOPT_0x10
; 0000 007A }
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R25,Y+
	LD   R1,Y+
	LD   R0,Y+
	RETI
;
;
;
;void indikator (void)
; 0000 007F {
_indikator:
; 0000 0080 switch (rejim)
	LDS  R30,_rejim
	RCALL SUBOPT_0x11
; 0000 0081     {
; 0000 0082     case 0:lcd_gotoxy(0,1); if(sw1==0) lcd_putsf("ǽyee ocao "); else lcd_putsf("ǽyee             ");
	SBIW R30,0
	BRNE _0x1B
	RCALL SUBOPT_0x12
	RCALL SUBOPT_0x13
	SBIC 0x13,5
	RJMP _0x1C
	__POINTW1FN _0x0,0
	RJMP _0xA7
_0x1C:
	__POINTW1FN _0x0,17
_0xA7:
	ST   -Y,R31
	ST   -Y,R30
	RCALL _lcd_putsf
; 0000 0083            lcd_gotoxy(0,0); sprintf(lcd_buffer,"taho=%u ,M=%u        ", taho ,pwm); break;
	RCALL SUBOPT_0x12
	RCALL SUBOPT_0x12
	RCALL _lcd_gotoxy
	RCALL SUBOPT_0x14
	__POINTW1FN _0x0,38
	RCALL SUBOPT_0x15
	RCALL SUBOPT_0x3
	RCALL __CWD1
	RCALL __PUTPARD1
	RCALL SUBOPT_0x5
	RCALL __CWD1
	RCALL __PUTPARD1
	LDI  R24,8
	RCALL _sprintf
	ADIW R28,12
	RJMP _0x1A
; 0000 0084     case 1:lcd_gotoxy(0,0); lcd_putsf("òop py     "); lcd_gotoxy(0,1);
_0x1B:
	RCALL SUBOPT_0x16
	BREQ PC+2
	RJMP _0x1E
	RCALL SUBOPT_0x12
	RCALL SUBOPT_0x12
	RCALL _lcd_gotoxy
	__POINTW1FN _0x0,62
	RCALL SUBOPT_0x17
	RCALL SUBOPT_0x13
; 0000 0085          switch(truba)
	RCALL SUBOPT_0x18
	RCALL SUBOPT_0x11
; 0000 0086         {
; 0000 0087         case 1: lcd_putsf("D20 PE32 6AT    "); break;
	RCALL SUBOPT_0x16
	BRNE _0x22
	__POINTW1FN _0x0,79
	RJMP _0xA8
; 0000 0088         case 2: lcd_putsf("D20 PE32 10AT   "); break;
_0x22:
	RCALL SUBOPT_0x19
	BRNE _0x23
	__POINTW1FN _0x0,96
	RJMP _0xA8
; 0000 0089         case 3: lcd_putsf("D20 PE63 10AT   "); break;
_0x23:
	RCALL SUBOPT_0x1A
	BRNE _0x24
	__POINTW1FN _0x0,113
	RJMP _0xA8
; 0000 008A         case 4: lcd_putsf("D20 PE80 12,5AT "); break;
_0x24:
	CPI  R30,LOW(0x4)
	LDI  R26,HIGH(0x4)
	CPC  R31,R26
	BRNE _0x25
	__POINTW1FN _0x0,130
	RJMP _0xA8
; 0000 008B         case 5: lcd_putsf("D20 PE80 16AT   "); break;
_0x25:
	CPI  R30,LOW(0x5)
	LDI  R26,HIGH(0x5)
	CPC  R31,R26
	BRNE _0x26
	__POINTW1FN _0x0,147
	RJMP _0xA8
; 0000 008C         case 6: lcd_putsf("D25 PE32 4AT    "); break;
_0x26:
	CPI  R30,LOW(0x6)
	LDI  R26,HIGH(0x6)
	CPC  R31,R26
	BRNE _0x27
	__POINTW1FN _0x0,164
	RJMP _0xA8
; 0000 008D         case 7: lcd_putsf("D25 PE32 6AT    "); break;
_0x27:
	CPI  R30,LOW(0x7)
	LDI  R26,HIGH(0x7)
	CPC  R31,R26
	BRNE _0x28
	__POINTW1FN _0x0,181
	RJMP _0xA8
; 0000 008E         case 8: lcd_putsf("D25 PE32 10AT   "); break;
_0x28:
	CPI  R30,LOW(0x8)
	LDI  R26,HIGH(0x8)
	CPC  R31,R26
	BRNE _0x29
	__POINTW1FN _0x0,198
	RJMP _0xA8
; 0000 008F         case 9: lcd_putsf("D25 PE63 6AT    "); break;
_0x29:
	CPI  R30,LOW(0x9)
	LDI  R26,HIGH(0x9)
	CPC  R31,R26
	BRNE _0x2A
	__POINTW1FN _0x0,215
	RJMP _0xA8
; 0000 0090         case 10: lcd_putsf("D25 PE63 10AT   "); break;
_0x2A:
	CPI  R30,LOW(0xA)
	LDI  R26,HIGH(0xA)
	CPC  R31,R26
	BRNE _0x2B
	__POINTW1FN _0x0,232
	RJMP _0xA8
; 0000 0091         case 11: lcd_putsf("D25 PE80 10AT   "); break;
_0x2B:
	CPI  R30,LOW(0xB)
	LDI  R26,HIGH(0xB)
	CPC  R31,R26
	BRNE _0x2C
	__POINTW1FN _0x0,249
	RJMP _0xA8
; 0000 0092         case 12: lcd_putsf("D25 PE80 12,5AT "); break;
_0x2C:
	CPI  R30,LOW(0xC)
	LDI  R26,HIGH(0xC)
	CPC  R31,R26
	BRNE _0x2D
	__POINTW1FN _0x0,266
	RJMP _0xA8
; 0000 0093         case 13: lcd_putsf("D25 PE80 16AT   "); break;
_0x2D:
	CPI  R30,LOW(0xD)
	LDI  R26,HIGH(0xD)
	CPC  R31,R26
	BRNE _0x2E
	__POINTW1FN _0x0,283
	RJMP _0xA8
; 0000 0094         case 14: lcd_putsf("D32 PE32 4AT    "); break;
_0x2E:
	CPI  R30,LOW(0xE)
	LDI  R26,HIGH(0xE)
	CPC  R31,R26
	BRNE _0x2F
	__POINTW1FN _0x0,300
	RJMP _0xA8
; 0000 0095         case 15: lcd_putsf("D32 PE32 6AT    "); break;
_0x2F:
	CPI  R30,LOW(0xF)
	LDI  R26,HIGH(0xF)
	CPC  R31,R26
	BRNE _0x30
	__POINTW1FN _0x0,317
	RJMP _0xA8
; 0000 0096         case 16: lcd_putsf("D32 PE32 10AT   "); break;
_0x30:
	CPI  R30,LOW(0x10)
	LDI  R26,HIGH(0x10)
	CPC  R31,R26
	BRNE _0x31
	__POINTW1FN _0x0,334
	RJMP _0xA8
; 0000 0097         case 17: lcd_putsf("D32 PE63 6AT    "); break;
_0x31:
	CPI  R30,LOW(0x11)
	LDI  R26,HIGH(0x11)
	CPC  R31,R26
	BRNE _0x32
	__POINTW1FN _0x0,351
	RJMP _0xA8
; 0000 0098         case 18: lcd_putsf("D32 PE63 10AT   "); break;
_0x32:
	CPI  R30,LOW(0x12)
	LDI  R26,HIGH(0x12)
	CPC  R31,R26
	BRNE _0x33
	__POINTW1FN _0x0,368
	RJMP _0xA8
; 0000 0099         case 19: lcd_putsf("D32 PE80 8AT    "); break;
_0x33:
	CPI  R30,LOW(0x13)
	LDI  R26,HIGH(0x13)
	CPC  R31,R26
	BRNE _0x34
	__POINTW1FN _0x0,385
	RJMP _0xA8
; 0000 009A         case 20: lcd_putsf("D32 PE80 10AT   "); break;
_0x34:
	CPI  R30,LOW(0x14)
	LDI  R26,HIGH(0x14)
	CPC  R31,R26
	BRNE _0x35
	__POINTW1FN _0x0,402
	RJMP _0xA8
; 0000 009B         case 21: lcd_putsf("D32 PE80 12,5AT "); break;
_0x35:
	CPI  R30,LOW(0x15)
	LDI  R26,HIGH(0x15)
	CPC  R31,R26
	BRNE _0x36
	__POINTW1FN _0x0,419
	RJMP _0xA8
; 0000 009C         case 22: lcd_putsf("D32 PE80 16AT   "); break;
_0x36:
	CPI  R30,LOW(0x16)
	LDI  R26,HIGH(0x16)
	CPC  R31,R26
	BRNE _0x37
	__POINTW1FN _0x0,436
	RJMP _0xA8
; 0000 009D         case 23: lcd_putsf("D40 PE32 4AT    "); break;
_0x37:
	CPI  R30,LOW(0x17)
	LDI  R26,HIGH(0x17)
	CPC  R31,R26
	BRNE _0x38
	__POINTW1FN _0x0,453
	RJMP _0xA8
; 0000 009E         case 24: lcd_putsf("D40 PE32 6AT    "); break;
_0x38:
	CPI  R30,LOW(0x18)
	LDI  R26,HIGH(0x18)
	CPC  R31,R26
	BRNE _0x39
	__POINTW1FN _0x0,470
	RJMP _0xA8
; 0000 009F         case 25: lcd_putsf("D40 PE32 10AT   "); break;
_0x39:
	CPI  R30,LOW(0x19)
	LDI  R26,HIGH(0x19)
	CPC  R31,R26
	BRNE _0x3A
	__POINTW1FN _0x0,487
	RJMP _0xA8
; 0000 00A0         case 26: lcd_putsf("D40 PE63 6AT    "); break;
_0x3A:
	CPI  R30,LOW(0x1A)
	LDI  R26,HIGH(0x1A)
	CPC  R31,R26
	BRNE _0x3B
	__POINTW1FN _0x0,504
	RJMP _0xA8
; 0000 00A1         case 27: lcd_putsf("D40 PE63 10AT   "); break;
_0x3B:
	CPI  R30,LOW(0x1B)
	LDI  R26,HIGH(0x1B)
	CPC  R31,R26
	BRNE _0x3C
	__POINTW1FN _0x0,521
	RJMP _0xA8
; 0000 00A2         case 28: lcd_putsf("D40 PE80 8AT    "); break;
_0x3C:
	CPI  R30,LOW(0x1C)
	LDI  R26,HIGH(0x1C)
	CPC  R31,R26
	BRNE _0x3D
	__POINTW1FN _0x0,538
	RJMP _0xA8
; 0000 00A3         case 29: lcd_putsf("D40 PE80 10AT   "); break;
_0x3D:
	CPI  R30,LOW(0x1D)
	LDI  R26,HIGH(0x1D)
	CPC  R31,R26
	BRNE _0x3E
	__POINTW1FN _0x0,555
	RJMP _0xA8
; 0000 00A4         case 30: lcd_putsf("D40 PE80 12,5AT "); break;
_0x3E:
	CPI  R30,LOW(0x1E)
	LDI  R26,HIGH(0x1E)
	CPC  R31,R26
	BRNE _0x3F
	__POINTW1FN _0x0,572
	RJMP _0xA8
; 0000 00A5         case 31: lcd_putsf("D40 PE80 16AT   "); break;
_0x3F:
	CPI  R30,LOW(0x1F)
	LDI  R26,HIGH(0x1F)
	CPC  R31,R26
	BRNE _0x40
	__POINTW1FN _0x0,589
	RJMP _0xA8
; 0000 00A6         case 32: lcd_putsf("D50 PE32 4AT    "); break;
_0x40:
	CPI  R30,LOW(0x20)
	LDI  R26,HIGH(0x20)
	CPC  R31,R26
	BRNE _0x41
	__POINTW1FN _0x0,606
	RJMP _0xA8
; 0000 00A7         case 33: lcd_putsf("D50 PE32 6AT    "); break;
_0x41:
	CPI  R30,LOW(0x21)
	LDI  R26,HIGH(0x21)
	CPC  R31,R26
	BRNE _0x42
	__POINTW1FN _0x0,623
	RJMP _0xA8
; 0000 00A8         case 34: lcd_putsf("D50 PE32 10AT   "); break;
_0x42:
	CPI  R30,LOW(0x22)
	LDI  R26,HIGH(0x22)
	CPC  R31,R26
	BRNE _0x43
	__POINTW1FN _0x0,640
	RJMP _0xA8
; 0000 00A9         case 35: lcd_putsf("D50 PE63 6AT    "); break;
_0x43:
	CPI  R30,LOW(0x23)
	LDI  R26,HIGH(0x23)
	CPC  R31,R26
	BRNE _0x44
	__POINTW1FN _0x0,657
	RJMP _0xA8
; 0000 00AA         case 36: lcd_putsf("D50 PE63 10AT   "); break;
_0x44:
	CPI  R30,LOW(0x24)
	LDI  R26,HIGH(0x24)
	CPC  R31,R26
	BRNE _0x45
	__POINTW1FN _0x0,674
	RJMP _0xA8
; 0000 00AB         case 37: lcd_putsf("D50 PE80 8AT    "); break;
_0x45:
	CPI  R30,LOW(0x25)
	LDI  R26,HIGH(0x25)
	CPC  R31,R26
	BRNE _0x46
	__POINTW1FN _0x0,691
	RJMP _0xA8
; 0000 00AC         case 38: lcd_putsf("D50 PE80 10AT   "); break;
_0x46:
	CPI  R30,LOW(0x26)
	LDI  R26,HIGH(0x26)
	CPC  R31,R26
	BRNE _0x47
	__POINTW1FN _0x0,708
	RJMP _0xA8
; 0000 00AD         case 39: lcd_putsf("D50 PE80 12,5AT "); break;
_0x47:
	CPI  R30,LOW(0x27)
	LDI  R26,HIGH(0x27)
	CPC  R31,R26
	BRNE _0x48
	__POINTW1FN _0x0,725
	RJMP _0xA8
; 0000 00AE         case 40: lcd_putsf("D50 PE80 16AT   "); break;
_0x48:
	CPI  R30,LOW(0x28)
	LDI  R26,HIGH(0x28)
	CPC  R31,R26
	BRNE _0x21
	__POINTW1FN _0x0,742
_0xA8:
	ST   -Y,R31
	ST   -Y,R30
	RCALL _lcd_putsf
; 0000 00AF         };
_0x21:
; 0000 00B0         break;
	RJMP _0x1A
; 0000 00B1     case 2:lcd_gotoxy(0,0);lcd_putsf("aae copc "); lcd_gotoxy(0,1); sprintf(lcd_buffer,"aae=%u       ",zadanie[truba]);break;
_0x1E:
	RCALL SUBOPT_0x19
	BRNE _0x4A
	RCALL SUBOPT_0x12
	RCALL SUBOPT_0x12
	RCALL _lcd_gotoxy
	__POINTW1FN _0x0,759
	RCALL SUBOPT_0x17
	RCALL SUBOPT_0x13
	RCALL SUBOPT_0x14
	__POINTW1FN _0x0,776
	RCALL SUBOPT_0x15
	RCALL SUBOPT_0x1
	RJMP _0xA9
; 0000 00B2     case 3:lcd_gotoxy(0,0);lcd_putsf("copc eocp  "); lcd_gotoxy(0,1); sprintf(lcd_buffer,"pwm=%u           ",pwm);break;
_0x4A:
	RCALL SUBOPT_0x1A
	BRNE _0x4B
	RCALL SUBOPT_0x12
	RCALL SUBOPT_0x12
	RCALL _lcd_gotoxy
	__POINTW1FN _0x0,794
	RCALL SUBOPT_0x17
	RCALL SUBOPT_0x13
	RCALL SUBOPT_0x14
	__POINTW1FN _0x0,811
	RCALL SUBOPT_0x15
	RCALL SUBOPT_0x5
	RJMP _0xA9
; 0000 00B3     case 4:lcd_gotoxy(0,0);lcd_putsf("e㸿e pea "); lcd_gotoxy(0,1); sprintf(lcd_buffer,"t=%u             ",ust_cnt_pwm);break;
_0x4B:
	CPI  R30,LOW(0x4)
	LDI  R26,HIGH(0x4)
	CPC  R31,R26
	BRNE _0x1A
	RCALL SUBOPT_0x12
	RCALL SUBOPT_0x12
	RCALL _lcd_gotoxy
	__POINTW1FN _0x0,829
	RCALL SUBOPT_0x17
	RCALL SUBOPT_0x13
	RCALL SUBOPT_0x14
	__POINTW1FN _0x0,846
	RCALL SUBOPT_0x15
	RCALL SUBOPT_0xC
_0xA9:
	RCALL __CWD1
	RCALL __PUTPARD1
	LDI  R24,4
	RCALL _sprintf
	ADIW R28,8
; 0000 00B4     };
_0x1A:
; 0000 00B5 lcd_puts(lcd_buffer);
	RCALL SUBOPT_0x14
	RCALL _lcd_puts
; 0000 00B6 
; 0000 00B7 }
	RET
;
;
;
;void knopki(void)
; 0000 00BC {
_knopki:
; 0000 00BD 
; 0000 00BE if((menu && enter && plus && minus)==0)
	SBIS 0x16,2
	RJMP _0x4E
	SBIS 0x16,3
	RJMP _0x4E
	SBIS 0x16,4
	RJMP _0x4E
	SBIC 0x16,5
	RJMP _0x4D
_0x4E:
; 0000 00BF {
; 0000 00C0 pauseind=0;
	CLR  R4
	CLR  R5
; 0000 00C1 ind=1;
	LDI  R30,LOW(1)
	STS  _ind,R30
; 0000 00C2 }
; 0000 00C3 if(menu==0)
_0x4D:
	SBIC 0x16,2
	RJMP _0x50
; 0000 00C4  {
; 0000 00C5  if(menu_pres==1)
	LDS  R26,_menu_pres
	CPI  R26,LOW(0x1)
	BRNE _0x51
; 0000 00C6   {
; 0000 00C7   rejim++;
	LDS  R30,_rejim
	SUBI R30,-LOW(1)
	STS  _rejim,R30
; 0000 00C8   if(rejim==5)rejim=0;
	RCALL SUBOPT_0x0
	CPI  R26,LOW(0x5)
	BRNE _0x52
	LDI  R30,LOW(0)
	STS  _rejim,R30
; 0000 00C9   menu_pres=0;
_0x52:
	LDI  R30,LOW(0)
	STS  _menu_pres,R30
; 0000 00CA   }
; 0000 00CB  }
_0x51:
; 0000 00CC else menu_pres=1;
	RJMP _0x53
_0x50:
	LDI  R30,LOW(1)
	STS  _menu_pres,R30
; 0000 00CD 
; 0000 00CE 
; 0000 00CF if (rejim==1)// 
_0x53:
	RCALL SUBOPT_0x0
	CPI  R26,LOW(0x1)
	BRNE _0x54
; 0000 00D0   {
; 0000 00D1        if(plus==0)
	SBIC 0x16,4
	RJMP _0x55
; 0000 00D2      {
; 0000 00D3      if(plus_pres==1)
	RCALL SUBOPT_0x1B
	BRNE _0x56
; 0000 00D4       {
; 0000 00D5       truba++;
	RCALL SUBOPT_0x1C
; 0000 00D6       if(truba==41)truba=1;
	LDS  R26,_truba
	CPI  R26,LOW(0x29)
	BRNE _0x57
	LDI  R30,LOW(1)
	RCALL SUBOPT_0x1D
; 0000 00D7       plus_pres=0;
_0x57:
	RCALL SUBOPT_0x1E
; 0000 00D8       }
; 0000 00D9      }
_0x56:
; 0000 00DA     else plus_pres=1;
	RJMP _0x58
_0x55:
	RCALL SUBOPT_0x1F
; 0000 00DB 
; 0000 00DC     if(minus==0)
_0x58:
	SBIC 0x16,5
	RJMP _0x59
; 0000 00DD      {
; 0000 00DE      if(minus_pres==1)
	RCALL SUBOPT_0x20
	BRNE _0x5A
; 0000 00DF       {
; 0000 00E0       truba--;
	RCALL SUBOPT_0x18
	SUBI R30,LOW(1)
	RCALL SUBOPT_0x1D
; 0000 00E1       if(truba==0)truba=40;
	RCALL SUBOPT_0x18
	CPI  R30,0
	BRNE _0x5B
	LDI  R30,LOW(40)
	RCALL SUBOPT_0x1D
; 0000 00E2       minus_pres=0;
_0x5B:
	RCALL SUBOPT_0x21
; 0000 00E3       }
; 0000 00E4      }
_0x5A:
; 0000 00E5     else minus_pres=1;
	RJMP _0x5C
_0x59:
	RCALL SUBOPT_0x22
; 0000 00E6   }
_0x5C:
; 0000 00E7 if(truba!=truba_mem)truba_mem=truba;
_0x54:
	LDI  R26,LOW(_truba_mem)
	LDI  R27,HIGH(_truba_mem)
	RCALL __EEPROMRDB
	LDS  R26,_truba
	CP   R30,R26
	BREQ _0x5D
	RCALL SUBOPT_0x18
	LDI  R26,LOW(_truba_mem)
	LDI  R27,HIGH(_truba_mem)
	RCALL __EEPROMWRB
; 0000 00E8 
; 0000 00E9 
; 0000 00EA 
; 0000 00EB 
; 0000 00EC if (rejim==2)//  
_0x5D:
	RCALL SUBOPT_0x0
	CPI  R26,LOW(0x2)
	BRNE _0x5E
; 0000 00ED   {
; 0000 00EE   if(plus==0 && zadanie[truba]<1000)
	RCALL SUBOPT_0x23
	BRNE _0x60
	RCALL SUBOPT_0x1
	CPI  R30,LOW(0x3E8)
	LDI  R26,HIGH(0x3E8)
	CPC  R31,R26
	BRLT _0x61
_0x60:
	RJMP _0x5F
_0x61:
; 0000 00EF    {
; 0000 00F0    if(plus_pres==1)
	RCALL SUBOPT_0x1B
	BRNE _0x62
; 0000 00F1     {
; 0000 00F2     plus_pres=0;
	RCALL SUBOPT_0x1E
; 0000 00F3     zadanie[truba]++;
	RCALL SUBOPT_0x24
; 0000 00F4     }
; 0000 00F5    else if(pz_btn>60)
	RJMP _0x63
_0x62:
	RCALL SUBOPT_0x25
	CPI  R26,LOW(0x3D)
	BRLO _0x64
; 0000 00F6     {
; 0000 00F7     plus_press=1;
	RCALL SUBOPT_0x26
; 0000 00F8     pz_btn=0;
; 0000 00F9     }
; 0000 00FA     if(pz_btn>10 && plus_press==1)
_0x64:
_0x63:
	RCALL SUBOPT_0x27
	BRLO _0x66
	RCALL SUBOPT_0x28
	BREQ _0x67
_0x66:
	RJMP _0x65
_0x67:
; 0000 00FB     {
; 0000 00FC     zadanie[truba]++;
	RCALL SUBOPT_0x24
; 0000 00FD     pz_btn=0;
	RCALL SUBOPT_0x29
; 0000 00FE     }
; 0000 00FF 
; 0000 0100 
; 0000 0101    }
_0x65:
; 0000 0102    else
	RJMP _0x68
_0x5F:
; 0000 0103    {
; 0000 0104    plus_pres=1;
	RCALL SUBOPT_0x1F
; 0000 0105    plus_press=0;
	RCALL SUBOPT_0x2A
; 0000 0106    }
_0x68:
; 0000 0107 
; 0000 0108 
; 0000 0109 
; 0000 010A     if(minus==0 && zadanie[truba]>1)
	RCALL SUBOPT_0x2B
	BRNE _0x6A
	RCALL SUBOPT_0x1
	SBIW R30,2
	BRGE _0x6B
_0x6A:
	RJMP _0x69
_0x6B:
; 0000 010B    {
; 0000 010C    if(minus_pres==1)
	RCALL SUBOPT_0x20
	BRNE _0x6C
; 0000 010D     {
; 0000 010E     minus_pres=0;
	RCALL SUBOPT_0x21
; 0000 010F     zadanie[truba]--;
	RCALL SUBOPT_0x2C
; 0000 0110     }
; 0000 0111    else if(pz_btn>60)
	RJMP _0x6D
_0x6C:
	RCALL SUBOPT_0x2D
	BRLO _0x6E
; 0000 0112     {
; 0000 0113     minus_press=1;
	RCALL SUBOPT_0x2E
; 0000 0114     pz_btn=0;
; 0000 0115     }
; 0000 0116     if(pz_btn>10 && minus_press==1)
_0x6E:
_0x6D:
	RCALL SUBOPT_0x27
	BRLO _0x70
	RCALL SUBOPT_0x2F
	BREQ _0x71
_0x70:
	RJMP _0x6F
_0x71:
; 0000 0117     {
; 0000 0118     zadanie[truba]--;
	RCALL SUBOPT_0x2C
; 0000 0119     pz_btn=0;
	RCALL SUBOPT_0x29
; 0000 011A     }
; 0000 011B 
; 0000 011C 
; 0000 011D    }
_0x6F:
; 0000 011E    else
	RJMP _0x72
_0x69:
; 0000 011F    {
; 0000 0120    minus_pres=1;
	RCALL SUBOPT_0x22
; 0000 0121    minus_press=0;
	RCALL SUBOPT_0x30
; 0000 0122    }
_0x72:
; 0000 0123   }
; 0000 0124 if(zadanie_mem[truba]!=zadanie[truba]) zadanie_mem[truba]=zadanie[truba];
_0x5E:
	RCALL SUBOPT_0x31
	RCALL SUBOPT_0xF
	RCALL __EEPROMRDW
	MOVW R0,R30
	RCALL SUBOPT_0x1
	CP   R30,R0
	CPC  R31,R1
	BREQ _0x73
	RCALL SUBOPT_0x31
	RCALL SUBOPT_0xE
	MOVW R0,R30
	RCALL SUBOPT_0x1
	MOVW R26,R0
	RCALL __EEPROMWRW
; 0000 0125 
; 0000 0126   if (rejim==3) //  
_0x73:
	RCALL SUBOPT_0x0
	CPI  R26,LOW(0x3)
	BRNE _0x74
; 0000 0127   {
; 0000 0128   if(plus==0 && pwm<725)
	RCALL SUBOPT_0x23
	BRNE _0x76
	RCALL SUBOPT_0xA
	CPI  R26,LOW(0x2D5)
	LDI  R30,HIGH(0x2D5)
	CPC  R27,R30
	BRLT _0x77
_0x76:
	RJMP _0x75
_0x77:
; 0000 0129    {
; 0000 012A    if(plus_pres==1)
	RCALL SUBOPT_0x1B
	BRNE _0x78
; 0000 012B     {
; 0000 012C     plus_pres=0;
	RCALL SUBOPT_0x1E
; 0000 012D     pwm++;
	RCALL SUBOPT_0x7
	RCALL SUBOPT_0x8
; 0000 012E     }
; 0000 012F    else if(pz_btn>60)
	RJMP _0x79
_0x78:
	RCALL SUBOPT_0x2D
	BRLO _0x7A
; 0000 0130     {
; 0000 0131     plus_press=1;
	RCALL SUBOPT_0x26
; 0000 0132     pz_btn=0;
; 0000 0133     }
; 0000 0134     if(pz_btn>10 && plus_press==1)
_0x7A:
_0x79:
	RCALL SUBOPT_0x27
	BRLO _0x7C
	RCALL SUBOPT_0x28
	BREQ _0x7D
_0x7C:
	RJMP _0x7B
_0x7D:
; 0000 0135     {
; 0000 0136     pwm++;
	RCALL SUBOPT_0x7
	RCALL SUBOPT_0x8
; 0000 0137     pz_btn=0;
	RCALL SUBOPT_0x29
; 0000 0138     }
; 0000 0139 
; 0000 013A 
; 0000 013B    }
_0x7B:
; 0000 013C    else
	RJMP _0x7E
_0x75:
; 0000 013D    {
; 0000 013E    plus_pres=1;
	RCALL SUBOPT_0x1F
; 0000 013F    plus_press=0;
	RCALL SUBOPT_0x2A
; 0000 0140    }
_0x7E:
; 0000 0141 
; 0000 0142 
; 0000 0143 
; 0000 0144     if(minus==0 && pwm>1)
	RCALL SUBOPT_0x2B
	BRNE _0x80
	RCALL SUBOPT_0xA
	SBIW R26,2
	BRGE _0x81
_0x80:
	RJMP _0x7F
_0x81:
; 0000 0145    {
; 0000 0146    if(minus_pres==1)
	RCALL SUBOPT_0x20
	BRNE _0x82
; 0000 0147     {
; 0000 0148     minus_pres=0;
	RCALL SUBOPT_0x21
; 0000 0149     pwm--;
	RCALL SUBOPT_0x7
	RCALL SUBOPT_0xB
; 0000 014A     }
; 0000 014B    else if(pz_btn>60)
	RJMP _0x83
_0x82:
	RCALL SUBOPT_0x2D
	BRLO _0x84
; 0000 014C     {
; 0000 014D     minus_press=1;
	RCALL SUBOPT_0x2E
; 0000 014E     pz_btn=0;
; 0000 014F     }
; 0000 0150     if(pz_btn>10 && minus_press==1)
_0x84:
_0x83:
	RCALL SUBOPT_0x27
	BRLO _0x86
	RCALL SUBOPT_0x2F
	BREQ _0x87
_0x86:
	RJMP _0x85
_0x87:
; 0000 0151     {
; 0000 0152     pwm--;
	RCALL SUBOPT_0x7
	RCALL SUBOPT_0xB
; 0000 0153     pz_btn=0;
	RCALL SUBOPT_0x29
; 0000 0154     }
; 0000 0155 
; 0000 0156 
; 0000 0157    }
_0x85:
; 0000 0158    else
	RJMP _0x88
_0x7F:
; 0000 0159    {
; 0000 015A    minus_pres=1;
	RCALL SUBOPT_0x22
; 0000 015B    minus_press=0;
	RCALL SUBOPT_0x30
; 0000 015C    }
_0x88:
; 0000 015D   }
; 0000 015E 
; 0000 015F 
; 0000 0160    if (rejim==4) //  
_0x74:
	RCALL SUBOPT_0x0
	CPI  R26,LOW(0x4)
	BRNE _0x89
; 0000 0161   {
; 0000 0162   if(plus==0 && ust_cnt_pwm<100)
	RCALL SUBOPT_0x23
	BRNE _0x8B
	RCALL SUBOPT_0x32
	CPI  R26,LOW(0x64)
	LDI  R30,HIGH(0x64)
	CPC  R27,R30
	BRLT _0x8C
_0x8B:
	RJMP _0x8A
_0x8C:
; 0000 0163    {
; 0000 0164    if(plus_pres==1)
	RCALL SUBOPT_0x1B
	BRNE _0x8D
; 0000 0165     {
; 0000 0166     plus_pres=0;
	RCALL SUBOPT_0x1E
; 0000 0167     ust_cnt_pwm++;
	RCALL SUBOPT_0x33
; 0000 0168     }
; 0000 0169    else if(pz_btn>60)
	RJMP _0x8E
_0x8D:
	RCALL SUBOPT_0x2D
	BRLO _0x8F
; 0000 016A     {
; 0000 016B     plus_press=1;
	RCALL SUBOPT_0x26
; 0000 016C     pz_btn=0;
; 0000 016D     }
; 0000 016E     if(pz_btn>10 && plus_press==1)
_0x8F:
_0x8E:
	RCALL SUBOPT_0x27
	BRLO _0x91
	RCALL SUBOPT_0x28
	BREQ _0x92
_0x91:
	RJMP _0x90
_0x92:
; 0000 016F     {
; 0000 0170     ust_cnt_pwm++;
	RCALL SUBOPT_0x33
; 0000 0171     pz_btn=0;
	RCALL SUBOPT_0x29
; 0000 0172     }
; 0000 0173 
; 0000 0174 
; 0000 0175    }
_0x90:
; 0000 0176    else
	RJMP _0x93
_0x8A:
; 0000 0177    {
; 0000 0178    plus_pres=1;
	RCALL SUBOPT_0x1F
; 0000 0179    plus_press=0;
	RCALL SUBOPT_0x2A
; 0000 017A    }
_0x93:
; 0000 017B 
; 0000 017C 
; 0000 017D 
; 0000 017E     if(minus==0 && ust_cnt_pwm>1)
	RCALL SUBOPT_0x2B
	BRNE _0x95
	RCALL SUBOPT_0x32
	SBIW R26,2
	BRGE _0x96
_0x95:
	RJMP _0x94
_0x96:
; 0000 017F    {
; 0000 0180    if(minus_pres==1)
	RCALL SUBOPT_0x20
	BRNE _0x97
; 0000 0181     {
; 0000 0182     minus_pres=0;
	RCALL SUBOPT_0x21
; 0000 0183     ust_cnt_pwm--;
	RCALL SUBOPT_0x34
; 0000 0184     }
; 0000 0185    else if(pz_btn>60)
	RJMP _0x98
_0x97:
	RCALL SUBOPT_0x2D
	BRLO _0x99
; 0000 0186     {
; 0000 0187     minus_press=1;
	RCALL SUBOPT_0x2E
; 0000 0188     pz_btn=0;
; 0000 0189     }
; 0000 018A     if(pz_btn>10 && minus_press==1)
_0x99:
_0x98:
	RCALL SUBOPT_0x27
	BRLO _0x9B
	RCALL SUBOPT_0x2F
	BREQ _0x9C
_0x9B:
	RJMP _0x9A
_0x9C:
; 0000 018B     {
; 0000 018C     ust_cnt_pwm--;
	RCALL SUBOPT_0x34
; 0000 018D     pz_btn=0;
	RCALL SUBOPT_0x29
; 0000 018E     }
; 0000 018F 
; 0000 0190 
; 0000 0191    }
_0x9A:
; 0000 0192    else
	RJMP _0x9D
_0x94:
; 0000 0193    {
; 0000 0194    minus_pres=1;
	RCALL SUBOPT_0x22
; 0000 0195    minus_press=0;
	RCALL SUBOPT_0x30
; 0000 0196    }
_0x9D:
; 0000 0197   }
; 0000 0198   if(ust_cnt_pwm_mem!=ust_cnt_pwm)ust_cnt_pwm_mem=ust_cnt_pwm;
_0x89:
	LDI  R26,LOW(_ust_cnt_pwm_mem)
	LDI  R27,HIGH(_ust_cnt_pwm_mem)
	RCALL __EEPROMRDB
	MOV  R26,R30
	RCALL SUBOPT_0xC
	RCALL SUBOPT_0xD
	BREQ _0x9E
	LDS  R30,_ust_cnt_pwm
	LDI  R26,LOW(_ust_cnt_pwm_mem)
	LDI  R27,HIGH(_ust_cnt_pwm_mem)
	RCALL __EEPROMWRB
; 0000 0199 }
_0x9E:
	RET
;
;
;// Declare your global variables here
;
;void main(void)
; 0000 019F {
_main:
; 0000 01A0 
; 0000 01A1 
; 0000 01A2 
; 0000 01A3 
; 0000 01A4 
; 0000 01A5 
; 0000 01A6 
; 0000 01A7 // Declare your local variables here
; 0000 01A8 
; 0000 01A9 // Input/Output Ports initialization
; 0000 01AA // Port B initialization
; 0000 01AB // Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=Out Func0=In
; 0000 01AC // State7=T State6=P State5=P State4=P State3=P State2=P State1=0 State0=T
; 0000 01AD PORTB=0x7C;
	LDI  R30,LOW(124)
	OUT  0x18,R30
; 0000 01AE DDRB=0x02;
	LDI  R30,LOW(2)
	OUT  0x17,R30
; 0000 01AF 
; 0000 01B0 // Port C initialization
; 0000 01B1 // Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In
; 0000 01B2 // State6=T State5=P State4=P State3=T State2=T State1=T State0=T
; 0000 01B3 PORTC=0x30;
	LDI  R30,LOW(48)
	OUT  0x15,R30
; 0000 01B4 DDRC=0x00;
	LDI  R30,LOW(0)
	OUT  0x14,R30
; 0000 01B5 
; 0000 01B6 // Port D initialization
; 0000 01B7 // Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In
; 0000 01B8 // State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T
; 0000 01B9 PORTD=0x00;
	OUT  0x12,R30
; 0000 01BA DDRD=0x00;
	OUT  0x11,R30
; 0000 01BB 
; 0000 01BC // Timer/Counter 0 initialization
; 0000 01BD // Clock source: System Clock
; 0000 01BE // Clock value: 15,625 kHz
; 0000 01BF TCCR0=0x03;
	LDI  R30,LOW(3)
	OUT  0x33,R30
; 0000 01C0 TCNT0=0x00;
	LDI  R30,LOW(0)
	OUT  0x32,R30
; 0000 01C1 
; 0000 01C2 // Timer/Counter 1 initialization
; 0000 01C3 // Clock source: System Clock
; 0000 01C4 // Clock value: 4000,000 kHz
; 0000 01C5 // Mode: Fast PWM top=03FFh
; 0000 01C6 // OC1A output: Inverted
; 0000 01C7 // OC1B output: Discon.
; 0000 01C8 // Noise Canceler: Off
; 0000 01C9 // Input Capture on Falling Edge
; 0000 01CA // Timer 1 Overflow Interrupt: Off
; 0000 01CB // Input Capture Interrupt: Off
; 0000 01CC // Compare A Match Interrupt: Off
; 0000 01CD // Compare B Match Interrupt: Off
; 0000 01CE TCCR1A=0xC3;
	LDI  R30,LOW(195)
	OUT  0x2F,R30
; 0000 01CF TCCR1B=0x09;
	LDI  R30,LOW(9)
	OUT  0x2E,R30
; 0000 01D0 TCNT1H=0x00;
	LDI  R30,LOW(0)
	OUT  0x2D,R30
; 0000 01D1 TCNT1L=0x00;
	OUT  0x2C,R30
; 0000 01D2 ICR1H=0x00;
	OUT  0x27,R30
; 0000 01D3 ICR1L=0x00;
	OUT  0x26,R30
; 0000 01D4 OCR1AH=0x00;
	OUT  0x2B,R30
; 0000 01D5 OCR1AL=0x00;
	OUT  0x2A,R30
; 0000 01D6 OCR1BH=0x00;
	OUT  0x29,R30
; 0000 01D7 OCR1BL=0x00;
	OUT  0x28,R30
; 0000 01D8 
; 0000 01D9 // Timer/Counter 2 initialization
; 0000 01DA // Clock source: System Clock
; 0000 01DB // Clock value: 62,500 kHz
; 0000 01DC // Mode: Normal top=FFh
; 0000 01DD // OC2 output: Disconnected
; 0000 01DE ASSR=0x00;
	OUT  0x22,R30
; 0000 01DF TCCR2=0x04;
	LDI  R30,LOW(4)
	OUT  0x25,R30
; 0000 01E0 TCNT2=0x00;
	LDI  R30,LOW(0)
	OUT  0x24,R30
; 0000 01E1 OCR2=0x00;
	OUT  0x23,R30
; 0000 01E2 
; 0000 01E3 // External Interrupt(s) initialization
; 0000 01E4 // INT0: Off
; 0000 01E5 // INT1: Off
; 0000 01E6 MCUCR=0x00;
	OUT  0x35,R30
; 0000 01E7 
; 0000 01E8 // Timer(s)/Counter(s) Interrupt(s) initialization
; 0000 01E9 TIMSK=0x41;
	LDI  R30,LOW(65)
	OUT  0x39,R30
; 0000 01EA 
; 0000 01EB // Analog Comparator initialization
; 0000 01EC // Analog Comparator: Off
; 0000 01ED // Analog Comparator Input Capture by Timer/Counter 1: Off
; 0000 01EE ACSR=0x80;
	LDI  R30,LOW(128)
	OUT  0x8,R30
; 0000 01EF SFIOR=0x00;
	LDI  R30,LOW(0)
	OUT  0x30,R30
; 0000 01F0 
; 0000 01F1 // ADC initialization
; 0000 01F2 // ADC Clock frequency: 31,250 kHz
; 0000 01F3 // ADC Voltage Reference: AVCC pin
; 0000 01F4 ADMUX=ADC_VREF_TYPE & 0xff;
	LDI  R30,LOW(64)
	OUT  0x7,R30
; 0000 01F5 ADCSRA=0x8F;
	LDI  R30,LOW(143)
	OUT  0x6,R30
; 0000 01F6 
; 0000 01F7 // LCD module initialization
; 0000 01F8 lcd_init(16);
	LDI  R30,LOW(16)
	ST   -Y,R30
	RCALL _lcd_init
; 0000 01F9 
; 0000 01FA // Watchdog Timer initialization
; 0000 01FB // Watchdog Timer Prescaler: OSC/2048k
; 0000 01FC #pragma optsize-
; 0000 01FD WDTCR=0x1F;
	LDI  R30,LOW(31)
	OUT  0x21,R30
; 0000 01FE WDTCR=0x0F;
	LDI  R30,LOW(15)
	OUT  0x21,R30
; 0000 01FF #ifdef _OPTIMIZE_SIZE_
; 0000 0200 #pragma optsize+
; 0000 0201 #endif
; 0000 0202 
; 0000 0203 // Global enable interrupts
; 0000 0204 #asm("sei")
	sei
; 0000 0205 ADCSRA|=0x40;
	RCALL SUBOPT_0x10
; 0000 0206 
; 0000 0207     for(truba=1;truba<40;truba++)
	LDI  R30,LOW(1)
	RCALL SUBOPT_0x1D
_0xA0:
	LDS  R26,_truba
	CPI  R26,LOW(0x28)
	BRSH _0xA1
; 0000 0208     {
; 0000 0209     zadanie[truba]=zadanie_mem[truba];
	RCALL SUBOPT_0x18
	LDI  R26,LOW(_zadanie)
	LDI  R27,HIGH(_zadanie)
	RCALL SUBOPT_0x11
	LSL  R30
	ROL  R31
	RCALL SUBOPT_0xE
	MOVW R0,R30
	RCALL SUBOPT_0x31
	RCALL SUBOPT_0xF
	RCALL __EEPROMRDW
	MOVW R26,R0
	ST   X+,R30
	ST   X,R31
; 0000 020A     }
	RCALL SUBOPT_0x1C
	RJMP _0xA0
_0xA1:
; 0000 020B truba=truba_mem;
	LDI  R26,LOW(_truba_mem)
	LDI  R27,HIGH(_truba_mem)
	RCALL __EEPROMRDB
	RCALL SUBOPT_0x1D
; 0000 020C ust_cnt_pwm=ust_cnt_pwm_mem;
	LDI  R26,LOW(_ust_cnt_pwm_mem)
	LDI  R27,HIGH(_ust_cnt_pwm_mem)
	RCALL __EEPROMRDB
	RCALL SUBOPT_0x11
	STS  _ust_cnt_pwm,R30
	STS  _ust_cnt_pwm+1,R31
; 0000 020D 
; 0000 020E while (1)
_0xA2:
; 0000 020F       {
; 0000 0210       // Place your code here
; 0000 0211       #asm("wdr")
	wdr
; 0000 0212       knopki();
	RCALL _knopki
; 0000 0213       indikator();
	RCALL _indikator
; 0000 0214 
; 0000 0215       };
	RJMP _0xA2
; 0000 0216 }
_0xA5:
	RJMP _0xA5
    .equ __lcd_direction=__lcd_port-1
    .equ __lcd_pin=__lcd_port-2
    .equ __lcd_rs=0
    .equ __lcd_rd=1
    .equ __lcd_enable=2
    .equ __lcd_busy_flag=7

	.DSEG

	.CSEG
__lcd_delay_G100:
    ldi   r31,15
__lcd_delay0:
    dec   r31
    brne  __lcd_delay0
	RET
__lcd_ready:
    in    r26,__lcd_direction
    andi  r26,0xf                 ;set as input
    out   __lcd_direction,r26
    sbi   __lcd_port,__lcd_rd     ;RD=1
    cbi   __lcd_port,__lcd_rs     ;RS=0
__lcd_busy:
	RCALL __lcd_delay_G100
    sbi   __lcd_port,__lcd_enable ;EN=1
	RCALL __lcd_delay_G100
    in    r26,__lcd_pin
    cbi   __lcd_port,__lcd_enable ;EN=0
	RCALL __lcd_delay_G100
    sbi   __lcd_port,__lcd_enable ;EN=1
	RCALL __lcd_delay_G100
    cbi   __lcd_port,__lcd_enable ;EN=0
    sbrc  r26,__lcd_busy_flag
    rjmp  __lcd_busy
	RET
__lcd_write_nibble_G100:
    andi  r26,0xf0
    or    r26,r27
    out   __lcd_port,r26          ;write
    sbi   __lcd_port,__lcd_enable ;EN=1
	RCALL __lcd_delay_G100
    cbi   __lcd_port,__lcd_enable ;EN=0
	RCALL __lcd_delay_G100
	RET
__lcd_write_data:
    cbi  __lcd_port,__lcd_rd 	  ;RD=0
    in    r26,__lcd_direction
    ori   r26,0xf0 | (1<<__lcd_rs) | (1<<__lcd_rd) | (1<<__lcd_enable) ;set as output
    out   __lcd_direction,r26
    in    r27,__lcd_port
    andi  r27,0xf
    ld    r26,y
	RCALL __lcd_write_nibble_G100
    ld    r26,y
    swap  r26
	RCALL __lcd_write_nibble_G100
    sbi   __lcd_port,__lcd_rd     ;RD=1
	RJMP _0x2080002
__lcd_read_nibble_G100:
    sbi   __lcd_port,__lcd_enable ;EN=1
	RCALL __lcd_delay_G100
    in    r30,__lcd_pin           ;read
    cbi   __lcd_port,__lcd_enable ;EN=0
	RCALL __lcd_delay_G100
    andi  r30,0xf0
	RET
_lcd_read_byte0_G100:
	RCALL __lcd_delay_G100
	RCALL __lcd_read_nibble_G100
    mov   r26,r30
	RCALL __lcd_read_nibble_G100
    cbi   __lcd_port,__lcd_rd     ;RD=0
    swap  r30
    or    r30,r26
	RET
_lcd_gotoxy:
	RCALL __lcd_ready
	LD   R30,Y
	RCALL SUBOPT_0x11
	SUBI R30,LOW(-__base_y_G100)
	SBCI R31,HIGH(-__base_y_G100)
	LD   R30,Z
	RCALL SUBOPT_0x11
	MOVW R26,R30
	LDD  R30,Y+1
	RCALL SUBOPT_0x11
	RCALL SUBOPT_0xE
	RCALL SUBOPT_0x35
	LDD  R30,Y+1
	STS  __lcd_x,R30
	LD   R30,Y
	STS  __lcd_y,R30
	ADIW R28,2
	RET
_lcd_clear:
	RCALL __lcd_ready
	LDI  R30,LOW(2)
	RCALL SUBOPT_0x35
	RCALL __lcd_ready
	LDI  R30,LOW(12)
	RCALL SUBOPT_0x35
	RCALL __lcd_ready
	LDI  R30,LOW(1)
	RCALL SUBOPT_0x35
	LDI  R30,LOW(0)
	STS  __lcd_y,R30
	STS  __lcd_x,R30
	RET
_lcd_putchar:
    push r30
    push r31
    ld   r26,y
    set
    cpi  r26,10
    breq __lcd_putchar1
    clt
	LDS  R30,__lcd_x
	SUBI R30,-LOW(1)
	STS  __lcd_x,R30
	LDS  R30,__lcd_maxx
	LDS  R26,__lcd_x
	CP   R30,R26
	BRSH _0x2000004
	__lcd_putchar1:
	LDS  R30,__lcd_y
	SUBI R30,-LOW(1)
	STS  __lcd_y,R30
	RCALL SUBOPT_0x12
	LDS  R30,__lcd_y
	ST   -Y,R30
	RCALL _lcd_gotoxy
	brts __lcd_putchar0
_0x2000004:
    rcall __lcd_ready
    sbi  __lcd_port,__lcd_rs ;RS=1
    ld   r26,y
    st   -y,r26
    rcall __lcd_write_data
__lcd_putchar0:
    pop  r31
    pop  r30
	RJMP _0x2080002
_lcd_puts:
	ST   -Y,R17
_0x2000005:
	LDD  R26,Y+1
	LDD  R27,Y+1+1
	LD   R30,X+
	STD  Y+1,R26
	STD  Y+1+1,R27
	MOV  R17,R30
	CPI  R30,0
	BREQ _0x2000007
	ST   -Y,R17
	RCALL _lcd_putchar
	RJMP _0x2000005
_0x2000007:
	RJMP _0x2080003
_lcd_putsf:
	ST   -Y,R17
_0x2000008:
	LDD  R30,Y+1
	LDD  R31,Y+1+1
	ADIW R30,1
	STD  Y+1,R30
	STD  Y+1+1,R31
	SBIW R30,1
	LPM  R30,Z
	MOV  R17,R30
	CPI  R30,0
	BREQ _0x200000A
	ST   -Y,R17
	RCALL _lcd_putchar
	RJMP _0x2000008
_0x200000A:
_0x2080003:
	LDD  R17,Y+0
	ADIW R28,3
	RET
__long_delay_G100:
    clr   r26
    clr   r27
__long_delay0:
    sbiw  r26,1         ;2 cycles
    brne  __long_delay0 ;2 cycles
	RET
__lcd_init_write_G100:
    cbi  __lcd_port,__lcd_rd 	  ;RD=0
    in    r26,__lcd_direction
    ori   r26,0xf7                ;set as output
    out   __lcd_direction,r26
    in    r27,__lcd_port
    andi  r27,0xf
    ld    r26,y
	RCALL __lcd_write_nibble_G100
    sbi   __lcd_port,__lcd_rd     ;RD=1
	RJMP _0x2080002
_lcd_init:
    cbi   __lcd_port,__lcd_enable ;EN=0
    cbi   __lcd_port,__lcd_rs     ;RS=0
	LD   R30,Y
	STS  __lcd_maxx,R30
	RCALL SUBOPT_0x11
	SUBI R30,LOW(-128)
	SBCI R31,HIGH(-128)
	__PUTB1MN __base_y_G100,2
	LD   R30,Y
	RCALL SUBOPT_0x11
	SUBI R30,LOW(-192)
	SBCI R31,HIGH(-192)
	__PUTB1MN __base_y_G100,3
	RCALL SUBOPT_0x36
	RCALL SUBOPT_0x36
	RCALL SUBOPT_0x36
	RCALL __long_delay_G100
	LDI  R30,LOW(32)
	ST   -Y,R30
	RCALL __lcd_init_write_G100
	RCALL __long_delay_G100
	LDI  R30,LOW(40)
	RCALL SUBOPT_0x35
	RCALL __long_delay_G100
	LDI  R30,LOW(4)
	RCALL SUBOPT_0x35
	RCALL __long_delay_G100
	LDI  R30,LOW(133)
	RCALL SUBOPT_0x35
	RCALL __long_delay_G100
    in    r26,__lcd_direction
    andi  r26,0xf                 ;set as input
    out   __lcd_direction,r26
    sbi   __lcd_port,__lcd_rd     ;RD=1
	RCALL _lcd_read_byte0_G100
	CPI  R30,LOW(0x5)
	BREQ _0x200000B
	LDI  R30,LOW(0)
	RJMP _0x2080001
_0x200000B:
	RCALL __lcd_ready
	LDI  R30,LOW(6)
	RCALL SUBOPT_0x35
	RCALL _lcd_clear
	LDI  R30,LOW(1)
	RJMP _0x2080001
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif

	.CSEG
_putchar:
     sbis usr,udre
     rjmp _putchar
     ld   r30,y
     out  udr,r30
_0x2080002:
_0x2080001:
	ADIW R28,1
	RET
__put_G101:
	RCALL __SAVELOCR2
	LDD  R26,Y+4
	LDD  R27,Y+4+1
	RCALL __GETW1P
	SBIW R30,0
	BREQ _0x2020010
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	RCALL __GETW1P
	MOVW R16,R30
	SBIW R30,0
	BREQ _0x2020012
	__CPWRN 16,17,2
	BRLO _0x2020013
	MOVW R30,R16
	SBIW R30,1
	MOVW R16,R30
	ST   X+,R30
	ST   X,R31
_0x2020012:
	LDD  R26,Y+4
	LDD  R27,Y+4+1
	LD   R30,X+
	LD   R31,X+
	RCALL SUBOPT_0x8
	SBIW R30,1
	LDD  R26,Y+6
	STD  Z+0,R26
_0x2020013:
	RJMP _0x2020014
_0x2020010:
	LDD  R30,Y+6
	ST   -Y,R30
	RCALL _putchar
_0x2020014:
	RCALL __LOADLOCR2
	ADIW R28,7
	RET
__print_G101:
	SBIW R28,6
	RCALL __SAVELOCR6
	LDI  R17,0
_0x2020015:
	LDD  R30,Y+18
	LDD  R31,Y+18+1
	ADIW R30,1
	STD  Y+18,R30
	STD  Y+18+1,R31
	SBIW R30,1
	LPM  R30,Z
	MOV  R18,R30
	CPI  R30,0
	BRNE PC+2
	RJMP _0x2020017
	MOV  R30,R17
	RCALL SUBOPT_0x11
	SBIW R30,0
	BRNE _0x202001B
	CPI  R18,37
	BRNE _0x202001C
	LDI  R17,LOW(1)
	RJMP _0x202001D
_0x202001C:
	RCALL SUBOPT_0x37
_0x202001D:
	RJMP _0x202001A
_0x202001B:
	RCALL SUBOPT_0x16
	BRNE _0x202001E
	CPI  R18,37
	BRNE _0x202001F
	RCALL SUBOPT_0x37
	RJMP _0x20200BC
_0x202001F:
	LDI  R17,LOW(2)
	LDI  R20,LOW(0)
	LDI  R16,LOW(0)
	CPI  R18,45
	BRNE _0x2020020
	LDI  R16,LOW(1)
	RJMP _0x202001A
_0x2020020:
	CPI  R18,43
	BRNE _0x2020021
	LDI  R20,LOW(43)
	RJMP _0x202001A
_0x2020021:
	CPI  R18,32
	BRNE _0x2020022
	LDI  R20,LOW(32)
	RJMP _0x202001A
_0x2020022:
	RJMP _0x2020023
_0x202001E:
	RCALL SUBOPT_0x19
	BRNE _0x2020024
_0x2020023:
	LDI  R21,LOW(0)
	LDI  R17,LOW(3)
	CPI  R18,48
	BRNE _0x2020025
	RCALL SUBOPT_0x38
	LDI  R30,LOW(128)
	LDI  R31,HIGH(128)
	RCALL SUBOPT_0x39
	RJMP _0x202001A
_0x2020025:
	RJMP _0x2020026
_0x2020024:
	RCALL SUBOPT_0x1A
	BREQ PC+2
	RJMP _0x202001A
_0x2020026:
	CPI  R18,48
	BRLO _0x2020029
	CPI  R18,58
	BRLO _0x202002A
_0x2020029:
	RJMP _0x2020028
_0x202002A:
	MOV  R26,R21
	RCALL SUBOPT_0x3A
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	MULS R30,R26
	MOVW R30,R0
	MOV  R21,R30
	MOV  R22,R21
	CLR  R23
	MOV  R26,R18
	RCALL SUBOPT_0x3A
	LDI  R30,LOW(48)
	LDI  R31,HIGH(48)
	RCALL __SWAPW12
	SUB  R30,R26
	SBC  R31,R27
	MOVW R26,R22
	ADD  R30,R26
	MOV  R21,R30
	RJMP _0x202001A
_0x2020028:
	MOV  R30,R18
	RCALL SUBOPT_0x11
	CPI  R30,LOW(0x63)
	LDI  R26,HIGH(0x63)
	CPC  R31,R26
	BRNE _0x202002E
	RCALL SUBOPT_0x3B
	RCALL SUBOPT_0x3C
	RCALL SUBOPT_0x3B
	LDD  R26,Z+4
	ST   -Y,R26
	RCALL SUBOPT_0x3D
	RJMP _0x202002F
_0x202002E:
	CPI  R30,LOW(0x73)
	LDI  R26,HIGH(0x73)
	CPC  R31,R26
	BRNE _0x2020031
	RCALL SUBOPT_0x3E
	RCALL SUBOPT_0x3F
	RCALL _strlen
	MOV  R17,R30
	RJMP _0x2020032
_0x2020031:
	CPI  R30,LOW(0x70)
	LDI  R26,HIGH(0x70)
	CPC  R31,R26
	BRNE _0x2020034
	RCALL SUBOPT_0x3E
	RCALL SUBOPT_0x3F
	RCALL _strlenf
	MOV  R17,R30
	RCALL SUBOPT_0x38
	LDI  R30,LOW(8)
	LDI  R31,HIGH(8)
	RCALL SUBOPT_0x39
_0x2020032:
	RCALL SUBOPT_0x38
	LDI  R30,LOW(2)
	LDI  R31,HIGH(2)
	RCALL SUBOPT_0x39
	RCALL SUBOPT_0x38
	LDI  R30,LOW(65407)
	LDI  R31,HIGH(65407)
	RCALL SUBOPT_0x40
	LDI  R19,LOW(0)
	RJMP _0x2020035
_0x2020034:
	CPI  R30,LOW(0x64)
	LDI  R26,HIGH(0x64)
	CPC  R31,R26
	BREQ _0x2020038
	CPI  R30,LOW(0x69)
	LDI  R26,HIGH(0x69)
	CPC  R31,R26
	BRNE _0x2020039
_0x2020038:
	RCALL SUBOPT_0x38
	RCALL SUBOPT_0x41
	RCALL SUBOPT_0x39
	RJMP _0x202003A
_0x2020039:
	CPI  R30,LOW(0x75)
	LDI  R26,HIGH(0x75)
	CPC  R31,R26
	BRNE _0x202003B
_0x202003A:
	LDI  R30,LOW(_tbl10_G101*2)
	LDI  R31,HIGH(_tbl10_G101*2)
	RCALL SUBOPT_0x42
	LDI  R17,LOW(5)
	RJMP _0x202003C
_0x202003B:
	CPI  R30,LOW(0x58)
	LDI  R26,HIGH(0x58)
	CPC  R31,R26
	BRNE _0x202003E
	RCALL SUBOPT_0x38
	LDI  R30,LOW(8)
	LDI  R31,HIGH(8)
	RCALL SUBOPT_0x39
	RJMP _0x202003F
_0x202003E:
	CPI  R30,LOW(0x78)
	LDI  R26,HIGH(0x78)
	CPC  R31,R26
	BREQ PC+2
	RJMP _0x2020070
_0x202003F:
	LDI  R30,LOW(_tbl16_G101*2)
	LDI  R31,HIGH(_tbl16_G101*2)
	RCALL SUBOPT_0x42
	LDI  R17,LOW(4)
_0x202003C:
	RCALL SUBOPT_0x38
	RCALL SUBOPT_0x43
	BREQ _0x2020041
	RCALL SUBOPT_0x3E
	RCALL SUBOPT_0x44
	LDD  R26,Y+11
	TST  R26
	BRPL _0x2020042
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	RCALL __ANEGW1
	STD  Y+10,R30
	STD  Y+10+1,R31
	LDI  R20,LOW(45)
_0x2020042:
	CPI  R20,0
	BREQ _0x2020043
	SUBI R17,-LOW(1)
	RJMP _0x2020044
_0x2020043:
	RCALL SUBOPT_0x38
	RCALL SUBOPT_0x45
_0x2020044:
	RJMP _0x2020045
_0x2020041:
	RCALL SUBOPT_0x3E
	RCALL SUBOPT_0x44
_0x2020045:
_0x2020035:
	RCALL SUBOPT_0x46
	BRNE _0x2020046
_0x2020047:
	CP   R17,R21
	BRSH _0x2020049
	RCALL SUBOPT_0x38
	RCALL SUBOPT_0x47
	BREQ _0x202004A
	RCALL SUBOPT_0x38
	RCALL SUBOPT_0x43
	BREQ _0x202004B
	RCALL SUBOPT_0x38
	RCALL SUBOPT_0x45
	MOV  R18,R20
	SUBI R17,LOW(1)
	RJMP _0x202004C
_0x202004B:
	LDI  R18,LOW(48)
_0x202004C:
	RJMP _0x202004D
_0x202004A:
	LDI  R18,LOW(32)
_0x202004D:
	RCALL SUBOPT_0x37
	SUBI R21,LOW(1)
	RJMP _0x2020047
_0x2020049:
_0x2020046:
	MOV  R19,R17
	RCALL SUBOPT_0x38
	LDI  R30,LOW(2)
	LDI  R31,HIGH(2)
	RCALL SUBOPT_0x48
	BREQ _0x202004E
_0x202004F:
	CPI  R19,0
	BREQ _0x2020051
	RCALL SUBOPT_0x38
	LDI  R30,LOW(8)
	LDI  R31,HIGH(8)
	RCALL SUBOPT_0x48
	BREQ _0x2020052
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ADIW R30,1
	RCALL SUBOPT_0x42
	SBIW R30,1
	LPM  R30,Z
	RJMP _0x20200BD
_0x2020052:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	LD   R30,X+
	STD  Y+6,R26
	STD  Y+6+1,R27
_0x20200BD:
	ST   -Y,R30
	RCALL SUBOPT_0x3D
	CPI  R21,0
	BREQ _0x2020054
	SUBI R21,LOW(1)
_0x2020054:
	SUBI R19,LOW(1)
	RJMP _0x202004F
_0x2020051:
	RJMP _0x2020055
_0x202004E:
_0x2020057:
	LDI  R18,LOW(48)
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	RCALL __GETW1PF
	STD  Y+8,R30
	STD  Y+8+1,R31
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ADIW R30,2
	RCALL SUBOPT_0x42
_0x2020059:
	LDD  R30,Y+8
	LDD  R31,Y+8+1
	LDD  R26,Y+10
	LDD  R27,Y+10+1
	CP   R26,R30
	CPC  R27,R31
	BRLO _0x202005B
	SUBI R18,-LOW(1)
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	SUB  R30,R26
	SBC  R31,R27
	STD  Y+10,R30
	STD  Y+10+1,R31
	RJMP _0x2020059
_0x202005B:
	CPI  R18,58
	BRLO _0x202005C
	RCALL SUBOPT_0x38
	LDI  R30,LOW(8)
	LDI  R31,HIGH(8)
	RCALL SUBOPT_0x48
	BREQ _0x202005D
	MOV  R30,R18
	RCALL SUBOPT_0x11
	ADIW R30,7
	RJMP _0x20200BE
_0x202005D:
	MOV  R30,R18
	RCALL SUBOPT_0x11
	ADIW R30,39
_0x20200BE:
	MOV  R18,R30
_0x202005C:
	RCALL SUBOPT_0x38
	LDI  R30,LOW(16)
	LDI  R31,HIGH(16)
	RCALL SUBOPT_0x48
	BRNE _0x2020060
	CPI  R18,49
	BRSH _0x2020062
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	SBIW R26,1
	BRNE _0x2020061
_0x2020062:
	RJMP _0x20200BF
_0x2020061:
	CP   R21,R19
	BRLO _0x2020066
	RCALL SUBOPT_0x46
	BREQ _0x2020067
_0x2020066:
	RJMP _0x2020065
_0x2020067:
	LDI  R18,LOW(32)
	RCALL SUBOPT_0x38
	RCALL SUBOPT_0x47
	BREQ _0x2020068
	LDI  R18,LOW(48)
_0x20200BF:
	MOV  R26,R16
	RCALL SUBOPT_0x3A
	LDI  R30,LOW(16)
	LDI  R31,HIGH(16)
	RCALL SUBOPT_0x39
	RCALL SUBOPT_0x38
	RCALL SUBOPT_0x43
	BREQ _0x2020069
	RCALL SUBOPT_0x38
	RCALL SUBOPT_0x45
	ST   -Y,R20
	RCALL SUBOPT_0x3D
	CPI  R21,0
	BREQ _0x202006A
	SUBI R21,LOW(1)
_0x202006A:
_0x2020069:
_0x2020068:
_0x2020060:
	RCALL SUBOPT_0x37
	CPI  R21,0
	BREQ _0x202006B
	SUBI R21,LOW(1)
_0x202006B:
_0x2020065:
	SUBI R19,LOW(1)
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	SBIW R26,2
	BRLO _0x2020058
	RJMP _0x2020057
_0x2020058:
_0x2020055:
	RCALL SUBOPT_0x46
	BREQ _0x202006C
_0x202006D:
	CPI  R21,0
	BREQ _0x202006F
	SUBI R21,LOW(1)
	LDI  R30,LOW(32)
	ST   -Y,R30
	RCALL SUBOPT_0x3D
	RJMP _0x202006D
_0x202006F:
_0x202006C:
_0x2020070:
_0x202002F:
_0x20200BC:
	LDI  R17,LOW(0)
_0x202001A:
	RJMP _0x2020015
_0x2020017:
	RCALL __LOADLOCR6
	ADIW R28,20
	RET
_sprintf:
	PUSH R15
	MOV  R15,R24
	SBIW R28,2
	RCALL __SAVELOCR2
	MOVW R26,R28
	RCALL __ADDW2R15
	MOVW R16,R26
	MOVW R26,R28
	ADIW R26,6
	RCALL __ADDW2R15
	RCALL __GETW1P
	STD  Y+2,R30
	STD  Y+2+1,R31
	MOVW R26,R28
	ADIW R26,4
	RCALL __ADDW2R15
	RCALL __GETW1P
	RCALL SUBOPT_0x15
	ST   -Y,R17
	ST   -Y,R16
	MOVW R30,R28
	ADIW R30,6
	RCALL SUBOPT_0x15
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	RCALL SUBOPT_0x15
	RCALL __print_G101
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	LDI  R30,LOW(0)
	ST   X,R30
	RCALL __LOADLOCR2
	ADIW R28,4
	POP  R15
	RET

	.CSEG

	.CSEG
_strlen:
    ld   r26,y+
    ld   r27,y+
    clr  r30
    clr  r31
strlen0:
    ld   r22,x+
    tst  r22
    breq strlen1
    adiw r30,1
    rjmp strlen0
strlen1:
    ret
_strlenf:
    clr  r26
    clr  r27
    ld   r30,y+
    ld   r31,y+
strlenf0:
    lpm  r0,z+
    tst  r0
    breq strlenf1
    adiw r26,1
    rjmp strlenf0
strlenf1:
    movw r30,r26
    ret

	.DSEG
_lcd_buffer:
	.BYTE 0x21
_taho5:
	.BYTE 0x2
_taho6:
	.BYTE 0x2
_taho7:
	.BYTE 0x2
_taho8:
	.BYTE 0x2
_taho9:
	.BYTE 0x2
_taho10:
	.BYTE 0x2
_taho11:
	.BYTE 0x2
_taho:
	.BYTE 0x2
_pwm:
	.BYTE 0x2
_zadanie:
	.BYTE 0x50
_ust_cnt_pwm:
	.BYTE 0x2
_truba:
	.BYTE 0x1
_ind:
	.BYTE 0x1
_rejim:
	.BYTE 0x1
_menu_pres:
	.BYTE 0x1
_plus_pres:
	.BYTE 0x1
_plus_press:
	.BYTE 0x1
_minus_pres:
	.BYTE 0x1
_minus_press:
	.BYTE 0x1
_pz_btn:
	.BYTE 0x1
_cnt_pwm:
	.BYTE 0x1

	.ESEG
_zadanie_mem:
	.BYTE 0x50
_ust_cnt_pwm_mem:
	.DB  0xA
_truba_mem:
	.DB  0x1

	.DSEG
__base_y_G100:
	.BYTE 0x4
__lcd_x:
	.BYTE 0x1
__lcd_y:
	.BYTE 0x1
__lcd_maxx:
	.BYTE 0x1
_p_S1030024:
	.BYTE 0x2

	.CSEG
;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x0:
	LDS  R26,_rejim
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 9 TIMES, CODE SIZE REDUCTION:86 WORDS
SUBOPT_0x1:
	LDS  R30,_truba
	LDI  R26,LOW(_zadanie)
	LDI  R27,HIGH(_zadanie)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	RCALL __GETW1P
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x2:
	LDS  R26,_taho
	LDS  R27,_taho+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x3:
	LDS  R30,_taho
	LDS  R31,_taho+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x4:
	LDS  R26,_pwm
	LDS  R27,_pwm+1
	CPI  R26,LOW(0x3E8)
	LDI  R30,HIGH(0x3E8)
	CPC  R27,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:13 WORDS
SUBOPT_0x5:
	LDS  R30,_pwm
	LDS  R31,_pwm+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x6:
	STS  _pwm,R30
	STS  _pwm+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:13 WORDS
SUBOPT_0x7:
	LDI  R26,LOW(_pwm)
	LDI  R27,HIGH(_pwm)
	LD   R30,X+
	LD   R31,X+
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:12 WORDS
SUBOPT_0x8:
	ADIW R30,1
	ST   -X,R31
	ST   -X,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x9:
	CP   R30,R26
	CPC  R31,R27
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0xA:
	LDS  R26,_pwm
	LDS  R27,_pwm+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:10 WORDS
SUBOPT_0xB:
	SBIW R30,1
	ST   -X,R31
	ST   -X,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0xC:
	LDS  R30,_ust_cnt_pwm
	LDS  R31,_ust_cnt_pwm+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0xD:
	LDI  R27,0
	RJMP SUBOPT_0x9

;OPTIMIZER ADDED SUBROUTINE, CALLED 9 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0xE:
	ADD  R30,R26
	ADC  R31,R27
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0xF:
	ADD  R26,R30
	ADC  R27,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x10:
	IN   R30,0x6
	LDI  R31,0
	ORI  R30,0x40
	OUT  0x6,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 23 TIMES, CODE SIZE REDUCTION:42 WORDS
SUBOPT_0x11:
	LDI  R31,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 16 TIMES, CODE SIZE REDUCTION:13 WORDS
SUBOPT_0x12:
	LDI  R30,LOW(0)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x13:
	LDI  R30,LOW(1)
	ST   -Y,R30
	RJMP _lcd_gotoxy

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:10 WORDS
SUBOPT_0x14:
	LDI  R30,LOW(_lcd_buffer)
	LDI  R31,HIGH(_lcd_buffer)
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 29 TIMES, CODE SIZE REDUCTION:26 WORDS
SUBOPT_0x15:
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x16:
	CPI  R30,LOW(0x1)
	LDI  R26,HIGH(0x1)
	CPC  R31,R26
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x17:
	RCALL SUBOPT_0x15
	RCALL _lcd_putsf
	RJMP SUBOPT_0x12

;OPTIMIZER ADDED SUBROUTINE, CALLED 14 TIMES, CODE SIZE REDUCTION:11 WORDS
SUBOPT_0x18:
	LDS  R30,_truba
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x19:
	CPI  R30,LOW(0x2)
	LDI  R26,HIGH(0x2)
	CPC  R31,R26
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x1A:
	CPI  R30,LOW(0x3)
	LDI  R26,HIGH(0x3)
	CPC  R31,R26
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x1B:
	LDS  R26,_plus_pres
	CPI  R26,LOW(0x1)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x1C:
	RCALL SUBOPT_0x18
	SUBI R30,-LOW(1)
	STS  _truba,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x1D:
	STS  _truba,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x1E:
	LDI  R30,LOW(0)
	STS  _plus_pres,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x1F:
	LDI  R30,LOW(1)
	STS  _plus_pres,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x20:
	LDS  R26,_minus_pres
	CPI  R26,LOW(0x1)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x21:
	LDI  R30,LOW(0)
	STS  _minus_pres,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x22:
	LDI  R30,LOW(1)
	STS  _minus_pres,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x23:
	LDI  R26,0
	SBIC 0x16,4
	LDI  R26,1
	CPI  R26,LOW(0x0)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x24:
	RCALL SUBOPT_0x18
	LDI  R26,LOW(_zadanie)
	LDI  R27,HIGH(_zadanie)
	RCALL SUBOPT_0x11
	LSL  R30
	ROL  R31
	RCALL SUBOPT_0xF
	LD   R30,X+
	LD   R31,X+
	RJMP SUBOPT_0x8

;OPTIMIZER ADDED SUBROUTINE, CALLED 12 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x25:
	LDS  R26,_pz_btn
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:8 WORDS
SUBOPT_0x26:
	LDI  R30,LOW(1)
	STS  _plus_press,R30
	LDI  R30,LOW(0)
	STS  _pz_btn,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x27:
	RCALL SUBOPT_0x25
	CPI  R26,LOW(0xB)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x28:
	LDS  R26,_plus_press
	CPI  R26,LOW(0x1)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 9 TIMES, CODE SIZE REDUCTION:14 WORDS
SUBOPT_0x29:
	LDI  R30,LOW(0)
	STS  _pz_btn,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x2A:
	LDI  R30,LOW(0)
	STS  _plus_press,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x2B:
	LDI  R26,0
	SBIC 0x16,5
	LDI  R26,1
	CPI  R26,LOW(0x0)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x2C:
	RCALL SUBOPT_0x18
	LDI  R26,LOW(_zadanie)
	LDI  R27,HIGH(_zadanie)
	RCALL SUBOPT_0x11
	LSL  R30
	ROL  R31
	RCALL SUBOPT_0xF
	LD   R30,X+
	LD   R31,X+
	RJMP SUBOPT_0xB

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x2D:
	RCALL SUBOPT_0x25
	CPI  R26,LOW(0x3D)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x2E:
	LDI  R30,LOW(1)
	STS  _minus_press,R30
	RJMP SUBOPT_0x29

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x2F:
	LDS  R26,_minus_press
	CPI  R26,LOW(0x1)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x30:
	LDI  R30,LOW(0)
	STS  _minus_press,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:8 WORDS
SUBOPT_0x31:
	RCALL SUBOPT_0x18
	LDI  R26,LOW(_zadanie_mem)
	LDI  R27,HIGH(_zadanie_mem)
	RCALL SUBOPT_0x11
	LSL  R30
	ROL  R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x32:
	LDS  R26,_ust_cnt_pwm
	LDS  R27,_ust_cnt_pwm+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x33:
	LDI  R26,LOW(_ust_cnt_pwm)
	LDI  R27,HIGH(_ust_cnt_pwm)
	LD   R30,X+
	LD   R31,X+
	RJMP SUBOPT_0x8

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x34:
	LDI  R26,LOW(_ust_cnt_pwm)
	LDI  R27,HIGH(_ust_cnt_pwm)
	LD   R30,X+
	LD   R31,X+
	RJMP SUBOPT_0xB

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x35:
	ST   -Y,R30
	RJMP __lcd_write_data

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x36:
	RCALL __long_delay_G100
	LDI  R30,LOW(48)
	ST   -Y,R30
	RJMP __lcd_init_write_G100

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:19 WORDS
SUBOPT_0x37:
	ST   -Y,R18
	LDD  R30,Y+15
	LDD  R31,Y+15+1
	RCALL SUBOPT_0x15
	MOVW R30,R28
	ADIW R30,15
	RCALL SUBOPT_0x15
	RJMP __put_G101

;OPTIMIZER ADDED SUBROUTINE, CALLED 18 TIMES, CODE SIZE REDUCTION:49 WORDS
SUBOPT_0x38:
	MOV  R26,R16
	LDI  R27,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x39:
	OR   R30,R26
	MOV  R16,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x3A:
	LDI  R27,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x3B:
	LDD  R30,Y+16
	LDD  R31,Y+16+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x3C:
	SBIW R30,4
	STD  Y+16,R30
	STD  Y+16+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:16 WORDS
SUBOPT_0x3D:
	LDD  R30,Y+15
	LDD  R31,Y+15+1
	RCALL SUBOPT_0x15
	MOVW R30,R28
	ADIW R30,15
	RCALL SUBOPT_0x15
	RJMP __put_G101

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x3E:
	RCALL SUBOPT_0x3B
	RJMP SUBOPT_0x3C

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x3F:
	LDD  R26,Y+16
	LDD  R27,Y+16+1
	ADIW R26,4
	RCALL __GETW1P
	STD  Y+6,R30
	STD  Y+6+1,R31
	RJMP SUBOPT_0x15

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x40:
	AND  R30,R26
	MOV  R16,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x41:
	LDI  R30,LOW(4)
	LDI  R31,HIGH(4)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x42:
	STD  Y+6,R30
	STD  Y+6+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x43:
	RCALL SUBOPT_0x41
	AND  R30,R26
	AND  R31,R27
	SBIW R30,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x44:
	LDD  R26,Y+16
	LDD  R27,Y+16+1
	ADIW R26,4
	RCALL __GETW1P
	STD  Y+10,R30
	STD  Y+10+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x45:
	LDI  R30,LOW(65531)
	LDI  R31,HIGH(65531)
	RJMP SUBOPT_0x40

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x46:
	MOV  R30,R16
	RCALL SUBOPT_0x11
	ANDI R30,LOW(0x1)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x47:
	LDI  R30,LOW(128)
	LDI  R31,HIGH(128)
	AND  R30,R26
	AND  R31,R27
	SBIW R30,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x48:
	AND  R30,R26
	AND  R31,R27
	SBIW R30,0
	RET


	.CSEG
__ADDW2R15:
	CLR  R0
	ADD  R26,R15
	ADC  R27,R0
	RET

__ANEGW1:
	NEG  R31
	NEG  R30
	SBCI R31,0
	RET

__ASRW8:
	MOV  R30,R31
	CLR  R31
	SBRC R30,7
	SER  R31
	RET

__CWD1:
	MOV  R22,R31
	ADD  R22,R22
	SBC  R22,R22
	MOV  R23,R22
	RET

__DIVW21U:
	CLR  R0
	CLR  R1
	LDI  R25,16
__DIVW21U1:
	LSL  R26
	ROL  R27
	ROL  R0
	ROL  R1
	SUB  R0,R30
	SBC  R1,R31
	BRCC __DIVW21U2
	ADD  R0,R30
	ADC  R1,R31
	RJMP __DIVW21U3
__DIVW21U2:
	SBR  R26,1
__DIVW21U3:
	DEC  R25
	BRNE __DIVW21U1
	MOVW R30,R26
	MOVW R26,R0
	RET

__DIVW21:
	RCALL __CHKSIGNW
	RCALL __DIVW21U
	BRTC __DIVW211
	RCALL __ANEGW1
__DIVW211:
	RET

__CHKSIGNW:
	CLT
	SBRS R31,7
	RJMP __CHKSW1
	RCALL __ANEGW1
	SET
__CHKSW1:
	SBRS R27,7
	RJMP __CHKSW2
	COM  R26
	COM  R27
	ADIW R26,1
	BLD  R0,0
	INC  R0
	BST  R0,0
__CHKSW2:
	RET

__GETW1P:
	LD   R30,X+
	LD   R31,X
	SBIW R26,1
	RET

__GETW1PF:
	LPM  R0,Z+
	LPM  R31,Z
	MOV  R30,R0
	RET

__PUTPARD1:
	ST   -Y,R23
	ST   -Y,R22
	ST   -Y,R31
	ST   -Y,R30
	RET

__SWAPW12:
	MOV  R1,R27
	MOV  R27,R31
	MOV  R31,R1

__SWAPB12:
	MOV  R1,R26
	MOV  R26,R30
	MOV  R30,R1
	RET

__EEPROMRDW:
	ADIW R26,1
	RCALL __EEPROMRDB
	MOV  R31,R30
	SBIW R26,1

__EEPROMRDB:
	SBIC EECR,EEWE
	RJMP __EEPROMRDB
	PUSH R31
	IN   R31,SREG
	CLI
	OUT  EEARL,R26
	OUT  EEARH,R27
	SBI  EECR,EERE
	IN   R30,EEDR
	OUT  SREG,R31
	POP  R31
	RET

__EEPROMWRW:
	RCALL __EEPROMWRB
	ADIW R26,1
	PUSH R30
	MOV  R30,R31
	RCALL __EEPROMWRB
	POP  R30
	SBIW R26,1
	RET

__EEPROMWRB:
	SBIS EECR,EEWE
	RJMP __EEPROMWRB1
	WDR
	RJMP __EEPROMWRB
__EEPROMWRB1:
	IN   R25,SREG
	CLI
	OUT  EEARL,R26
	OUT  EEARH,R27
	SBI  EECR,EERE
	IN   R24,EEDR
	CP   R30,R24
	BREQ __EEPROMWRB0
	OUT  EEDR,R30
	SBI  EECR,EEMWE
	SBI  EECR,EEWE
__EEPROMWRB0:
	OUT  SREG,R25
	RET

__CPW02:
	CLR  R0
	CP   R0,R26
	CPC  R0,R27
	RET

__SAVELOCR6:
	ST   -Y,R21
__SAVELOCR5:
	ST   -Y,R20
__SAVELOCR4:
	ST   -Y,R19
__SAVELOCR3:
	ST   -Y,R18
__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR6:
	LDD  R21,Y+5
__LOADLOCR5:
	LDD  R20,Y+4
__LOADLOCR4:
	LDD  R19,Y+3
__LOADLOCR3:
	LDD  R18,Y+2
__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

;END OF CODE MARKER
__END_OF_CODE:
