
#pragma used+
sfrb TWBR=0;
sfrb TWSR=1;
sfrb TWAR=2;
sfrb TWDR=3;
sfrb ADCL=4;
sfrb ADCH=5;
sfrw ADCW=4;      
sfrb ADCSRA=6;
sfrb ADMUX=7;
sfrb ACSR=8;
sfrb UBRRL=9;
sfrb UCSRB=0xa;
sfrb UCSRA=0xb;
sfrb UDR=0xc;
sfrb SPCR=0xd;
sfrb SPSR=0xe;
sfrb SPDR=0xf;
sfrb PIND=0x10;
sfrb DDRD=0x11;
sfrb PORTD=0x12;
sfrb PINC=0x13;
sfrb DDRC=0x14;
sfrb PORTC=0x15;
sfrb PINB=0x16;
sfrb DDRB=0x17;
sfrb PORTB=0x18;
sfrb EECR=0x1c;
sfrb EEDR=0x1d;
sfrb EEARL=0x1e;
sfrb EEARH=0x1f;
sfrw EEAR=0x1e;   
sfrb UBRRH=0x20;
sfrb UCSRC=0X20;
sfrb WDTCR=0x21;
sfrb ASSR=0x22;
sfrb OCR2=0x23;
sfrb TCNT2=0x24;
sfrb TCCR2=0x25;
sfrb ICR1L=0x26;
sfrb ICR1H=0x27;
sfrw ICR1=0x26;   
sfrb OCR1BL=0x28;
sfrb OCR1BH=0x29;
sfrw OCR1B=0x28;  
sfrb OCR1AL=0x2a;
sfrb OCR1AH=0x2b;
sfrw OCR1A=0x2a;  
sfrb TCNT1L=0x2c;
sfrb TCNT1H=0x2d;
sfrw TCNT1=0x2c;  
sfrb TCCR1B=0x2e;
sfrb TCCR1A=0x2f;
sfrb SFIOR=0x30;
sfrb OSCCAL=0x31;
sfrb TCNT0=0x32;
sfrb TCCR0=0x33;
sfrb MCUCSR=0x34;
sfrb MCUCR=0x35;
sfrb TWCR=0x36;
sfrb SPMCR=0x37;
sfrb TIFR=0x38;
sfrb TIMSK=0x39;
sfrb GIFR=0x3a;
sfrb GICR=0x3b;
sfrb SPL=0x3d;
sfrb SPH=0x3e;
sfrb SREG=0x3f;
#pragma used-

#asm
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
#endasm

#asm
   .equ __lcd_port=0x12 ;PORTD
#endasm

#pragma used+

void _lcd_ready(void);
void _lcd_write_data(unsigned char data);

void lcd_write_byte(unsigned char addr, unsigned char data);

unsigned char lcd_read_byte(unsigned char addr);

void lcd_gotoxy(unsigned char x, unsigned char y);

void lcd_clear(void);
void lcd_putchar(char c);

void lcd_puts(char *str);

void lcd_putsf(char flash *str);

unsigned char lcd_init(unsigned char lcd_columns);

#pragma used-
#pragma library lcd.lib

typedef char *va_list;

#pragma used+

char getchar(void);
void putchar(char c);
void puts(char *str);
void putsf(char flash *str);

char *gets(char *str,unsigned int len);

void printf(char flash *fmtstr,...);
void sprintf(char *str, char flash *fmtstr,...);
void snprintf(char *str, unsigned int size, char flash *fmtstr,...);
void vprintf (char flash * fmtstr, va_list argptr);
void vsprintf (char *str, char flash * fmtstr, va_list argptr);
void vsnprintf (char *str, unsigned int size, char flash * fmtstr, va_list argptr);
signed char scanf(char flash *fmtstr,...);
signed char sscanf(char *str, char flash *fmtstr,...);

#pragma used-

#pragma library stdio.lib

char lcd_buffer[33];
int  pauseind, taho1, taho2, taho3, taho4, taho5, taho6, taho7, taho8, taho9, taho10,taho11, taho, pwm, zadanie[40], ust_cnt_pwm;
unsigned char   truba, ind,  rejim, menu_pres,plus_pres, plus_press, minus_pres, minus_press,pz_btn, cnt_pwm;
eeprom int zadanie_mem[40]; 
eeprom unsigned char ust_cnt_pwm_mem=10, truba_mem=1;

void vichisl (void)
{
if(rejim!=3)
{
if(taho<zadanie[truba])
{
if(taho+50<zadanie[truba] && pwm<1000)pwm=pwm+5;
else
{
if(pwm<1000) pwm++;
}
}
if(taho>zadanie[truba])
{
if(taho>zadanie[truba]+50 && pwm>5)pwm=pwm-5;
else
{
if(pwm>0) pwm--;
}
}
} 
if(PINC.5==0)pwm=0;
OCR1AH=pwm>>8;
OCR1AL=pwm;

}

interrupt [10] void timer0_ovf_isr(void)
{

if(ind!=0)pauseind++;
if(pauseind==1000)
{
rejim=0;
ind=0;
pauseind=0;
}

cnt_pwm++;
if(cnt_pwm==ust_cnt_pwm)
{
cnt_pwm=0;
vichisl();
}
if( (plus_pres && minus_pres)==0)pz_btn++;
else pz_btn=0;  
}

interrupt [5] void timer2_ovf_isr(void)
{

}

interrupt [15] void adc_isr(void)
{

taho11=taho10;
taho10=taho9;
taho9=taho8;
taho8=taho7;
taho7=taho6;
taho6=taho5;
taho5=taho4;
taho4=taho3; 
taho3=taho2;
taho2=taho1;
taho1=ADCW;
taho=(taho1+taho2+taho3+taho4+taho5+taho6+taho7+taho8+taho9+taho10+taho11)/11;

ADCSRA|=0x40;
}

void indikator (void)
{
switch (rejim)
{
case 0:lcd_gotoxy(0,1); if(PINC.5==0) lcd_putsf("ǽyee ocao "); else lcd_putsf("ǽyee             ");
lcd_gotoxy(0,0); sprintf(lcd_buffer,"taho=%u ,M=%u        ", taho ,pwm); break; 
case 1:lcd_gotoxy(0,0); lcd_putsf("òop py     "); lcd_gotoxy(0,1);
switch(truba)
{
case 1: lcd_putsf("D20 PE32 6AT    "); break;
case 2: lcd_putsf("D20 PE32 10AT   "); break;
case 3: lcd_putsf("D20 PE63 10AT   "); break;
case 4: lcd_putsf("D20 PE80 12,5AT "); break;
case 5: lcd_putsf("D20 PE80 16AT   "); break;
case 6: lcd_putsf("D25 PE32 4AT    "); break;
case 7: lcd_putsf("D25 PE32 6AT    "); break;
case 8: lcd_putsf("D25 PE32 10AT   "); break;
case 9: lcd_putsf("D25 PE63 6AT    "); break;
case 10: lcd_putsf("D25 PE63 10AT   "); break;
case 11: lcd_putsf("D25 PE80 10AT   "); break;
case 12: lcd_putsf("D25 PE80 12,5AT "); break;
case 13: lcd_putsf("D25 PE80 16AT   "); break;
case 14: lcd_putsf("D32 PE32 4AT    "); break;
case 15: lcd_putsf("D32 PE32 6AT    "); break;
case 16: lcd_putsf("D32 PE32 10AT   "); break;
case 17: lcd_putsf("D32 PE63 6AT    "); break;
case 18: lcd_putsf("D32 PE63 10AT   "); break;
case 19: lcd_putsf("D32 PE80 8AT    "); break;
case 20: lcd_putsf("D32 PE80 10AT   "); break;
case 21: lcd_putsf("D32 PE80 12,5AT "); break;
case 22: lcd_putsf("D32 PE80 16AT   "); break;
case 23: lcd_putsf("D40 PE32 4AT    "); break;
case 24: lcd_putsf("D40 PE32 6AT    "); break;
case 25: lcd_putsf("D40 PE32 10AT   "); break;
case 26: lcd_putsf("D40 PE63 6AT    "); break;
case 27: lcd_putsf("D40 PE63 10AT   "); break;
case 28: lcd_putsf("D40 PE80 8AT    "); break;
case 29: lcd_putsf("D40 PE80 10AT   "); break;
case 30: lcd_putsf("D40 PE80 12,5AT "); break;
case 31: lcd_putsf("D40 PE80 16AT   "); break;
case 32: lcd_putsf("D50 PE32 4AT    "); break;
case 33: lcd_putsf("D50 PE32 6AT    "); break;
case 34: lcd_putsf("D50 PE32 10AT   "); break;
case 35: lcd_putsf("D50 PE63 6AT    "); break;
case 36: lcd_putsf("D50 PE63 10AT   "); break;
case 37: lcd_putsf("D50 PE80 8AT    "); break;
case 38: lcd_putsf("D50 PE80 10AT   "); break;
case 39: lcd_putsf("D50 PE80 12,5AT "); break;
case 40: lcd_putsf("D50 PE80 16AT   "); break;
};
break;
case 2:lcd_gotoxy(0,0);lcd_putsf("aae copc "); lcd_gotoxy(0,1); sprintf(lcd_buffer,"aae=%u       ",zadanie[truba]);break;
case 3:lcd_gotoxy(0,0);lcd_putsf("copc eocp  "); lcd_gotoxy(0,1); sprintf(lcd_buffer,"pwm=%u           ",pwm);break;
case 4:lcd_gotoxy(0,0);lcd_putsf("e㸿e pea "); lcd_gotoxy(0,1); sprintf(lcd_buffer,"t=%u             ",ust_cnt_pwm);break;
}; 
lcd_puts(lcd_buffer);

}

void knopki(void)
{

if((PINB.2 && PINB.3 && PINB.4 && PINB.5)==0)
{
pauseind=0;
ind=1;
}
if(PINB.2==0)
{
if(menu_pres==1)
{
rejim++;
if(rejim==5)rejim=0;
menu_pres=0;
}
}
else menu_pres=1;  

if (rejim==1)
{
if(PINB.4==0)
{
if(plus_pres==1)
{
truba++;
if(truba==41)truba=1;
plus_pres=0;
}
}
else plus_pres=1;

if(PINB.5==0)
{
if(minus_pres==1)
{
truba--;
if(truba==0)truba=40;
minus_pres=0;
}
}
else minus_pres=1;
} 
if(truba!=truba_mem)truba_mem=truba; 

if (rejim==2)
{
if(PINB.4==0 && zadanie[truba]<1000)
{
if(plus_pres==1)
{
plus_pres=0;
zadanie[truba]++;
}
else if(pz_btn>60)
{
plus_press=1;
pz_btn=0;
}
if(pz_btn>10 && plus_press==1)
{
zadanie[truba]++;
pz_btn=0;
}

}
else 
{
plus_pres=1;
plus_press=0;
}   

if(PINB.5==0 && zadanie[truba]>1)
{
if(minus_pres==1)
{
minus_pres=0;
zadanie[truba]--;
}
else if(pz_btn>60)
{
minus_press=1;
pz_btn=0;
}
if(pz_btn>10 && minus_press==1)
{
zadanie[truba]--;
pz_btn=0;
}

}
else 
{
minus_pres=1;
minus_press=0;
}   
} 
if(zadanie_mem[truba]!=zadanie[truba]) zadanie_mem[truba]=zadanie[truba];  

if (rejim==3) 
{
if(PINB.4==0 && pwm<725)
{
if(plus_pres==1)
{
plus_pres=0;
pwm++;
}
else if(pz_btn>60)
{
plus_press=1;
pz_btn=0;
}
if(pz_btn>10 && plus_press==1)
{
pwm++;
pz_btn=0;
}

}
else 
{
plus_pres=1;
plus_press=0;
}   

if(PINB.5==0 && pwm>1)
{
if(minus_pres==1)
{
minus_pres=0;
pwm--;
}
else if(pz_btn>60)
{
minus_press=1;
pz_btn=0;
}
if(pz_btn>10 && minus_press==1)
{
pwm--;
pz_btn=0;
}

}
else 
{
minus_pres=1;
minus_press=0;
}   
}

if (rejim==4) 
{
if(PINB.4==0 && ust_cnt_pwm<100)
{
if(plus_pres==1)
{
plus_pres=0;
ust_cnt_pwm++;
}
else if(pz_btn>60)
{
plus_press=1;
pz_btn=0;
}
if(pz_btn>10 && plus_press==1)
{
ust_cnt_pwm++;
pz_btn=0;
}

}
else 
{
plus_pres=1;
plus_press=0;
}   

if(PINB.5==0 && ust_cnt_pwm>1) 
{
if(minus_pres==1)
{
minus_pres=0;
ust_cnt_pwm--;
}
else if(pz_btn>60)
{
minus_press=1;
pz_btn=0;
}
if(pz_btn>10 && minus_press==1)
{
ust_cnt_pwm--;
pz_btn=0;
}

}
else 
{
minus_pres=1;
minus_press=0;
}   
}
if(ust_cnt_pwm_mem!=ust_cnt_pwm)ust_cnt_pwm_mem=ust_cnt_pwm;                      
}

void main(void)
{

PORTB=0x7C;
DDRB=0x02;

PORTC=0x30;
DDRC=0x00;

PORTD=0x00;
DDRD=0x00;

TCCR0=0x03;
TCNT0=0x00;

TCCR1A=0xC3;
TCCR1B=0x09;
TCNT1H=0x00;
TCNT1L=0x00;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x00;
OCR1AL=0x00;
OCR1BH=0x00;
OCR1BL=0x00;

ASSR=0x00;
TCCR2=0x04;
TCNT2=0x00;
OCR2=0x00;

MCUCR=0x00;

TIMSK=0x41;

ACSR=0x80;
SFIOR=0x00;

ADMUX=0x40 & 0xff;
ADCSRA=0x8F;

lcd_init(16);

#pragma optsize-
WDTCR=0x1F;
WDTCR=0x0F;
#pragma optsize+

#asm("sei")
ADCSRA|=0x40;

for(truba=1;truba<40;truba++)
{
zadanie[truba]=zadanie_mem[truba];
}  
truba=truba_mem;
ust_cnt_pwm=ust_cnt_pwm_mem;

while (1)
{

#asm("wdr")
knopki();
indikator();

};
}
